var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
require('@host');
require('angular-ui-grid/ui-grid.js');
// import '@host';
// import '../../scripts/dependencies/ui-grid';
// import '../../scripts/dependencies/json-editor';
// import '../../scripts/dependencies/ace';
// import '../../scripts/directives/edit-json-text';
// import 'angular-animate';
// import '../../styles/animations.scss';
require('./data.scss');
// // Angular-toastr
// import 'angular-toastr/dist/angular-toastr.js';
// import 'angular-toastr/dist/angular-toastr.tpls.js';
// import 'angular-toastr/dist/angular-toastr.css';
//
// // Angular ui layout
// import 'angular-ui-layout/src/ui-layout.js';
// import 'angular-ui-layout/src/ui-layout.css';
require('../query-editor/query-editor.component');
var component_1 = require('../../scripts/decorators/component');
var hot_reload_1 = require('../../scripts/decorators/hot-reload');
var view_1 = require('../../scripts/decorators/view');
var inject_1 = require('../../scripts/decorators/inject');
var data_service_1 = require('./data-service');
var DataComponent = (function () {
    function DataComponent() {
        var _this = this;
        // TODO: interface for loopback models
        this.models = {};
        this.optionsTabs = ['options', 'JSON'];
        this.optionsTab = this.optionsTabs[0];
        this.limit = 50;
        this.offset = 0;
        this.order = null;
        this.loading = true;
        this.query = [];
        this.interacted = false;
        this.gridOptions = {
            enableRowSelection: true,
            rowEditWaitInterval: 1,
            multiSelect: false,
            // We are using our own selection template instead
            selectionRowHeaderWidth: 0,
            checkboxCellTemplate: 'edit',
            checkboxHeaderTemplate: '',
            // enableRowHashing: false,
            paginationPageSize: this.limit,
            paginationPageSizes: /* false, // */ [25, 50, 100],
            useExternalPagination: true,
            useExternalSorting: true,
            data: [],
            onRegisterApi: function (gridApi) {
                _this.gridApi = gridApi;
                // TODO: not working
                gridApi.rowEdit.on.saveRow(_this.$scope, function (model) {
                    var promise = _this
                        .data
                        .putModelData(_this.activeModel.name, model)
                        .then(function () {
                        _this.notifySaved();
                    });
                    gridApi.rowEdit.setSavePromise(model, promise);
                });
                gridApi.core.on.sortChanged(_this.$scope, function (grid, sortColumns) {
                    if (sortColumns.length) {
                        var column = sortColumns[0];
                        _this.order = column.field + " " + column.sort.direction.toUpperCase();
                    }
                    else {
                        _this.order = null;
                    }
                    _this.reload();
                });
                gridApi.pagination.on.paginationChanged(_this.$scope, function (newPage, pageSize) {
                    _this.limit = pageSize;
                    _this.offset = newPage - 1;
                    _this.reload();
                });
                gridApi.selection.on.rowSelectionChanged(_this.$scope, function (row) {
                    _this.onRowChanged(row);
                });
            }
        };
        this
            .getModels()
            .then(function () {
            var model = _this.models[_this.$stateParams.type] || _this.modelsList[0];
            if (model) {
                return _this.loadModel(model.name);
            }
        })
            .then(function () {
            var id = _this.$stateParams.id;
            if (id) {
                var index = _.findIndex(_this.gridOptions.data, function (item) {
                    return item.id === id;
                });
                _this.$timeout(function () {
                    // TODO: use selectRow instead
                    _this.gridApi.selection.selectRowByVisibleIndex(index);
                });
            }
        });
        this.setWatchers();
    }
    DataComponent.prototype.notifySaved = function () {
        this.toastr.success('Saved');
    };
    // TODO: find better workaround for this
    DataComponent.prototype.editorInit = function (scope) {
        var _this = this;
        _.defer(function () {
            _this.editor = scope.editor;
        });
    };
    DataComponent.prototype.codeEditorInit = function (scope) {
        var _this = this;
        _.defer(function () {
            _this.codeEditor = scope.editor;
        });
    };
    DataComponent.prototype.onJsonEditorChange = function (value) {
        _.merge(this.selectedRow.entity, value);
    };
    DataComponent.prototype.onCodeEditorChange = function (value) {
        _.merge(this.selectedRow.entity.templateCode, value);
    };
    DataComponent.prototype.cloneActiveModel = function () {
        var model = this.selectedRow.entity;
        this.createNewComponent(_.omit(model, 'id', '_id'));
    };
    /**
     * Hack to submit updates on every keypress.
     * @todo there has to be a better way built-in
     */
    DataComponent.prototype.onEditorKeypress = function (event) {
        var target = event.target;
        var evt = document.createEvent('HTMLEvents');
        evt.initEvent('change', false, true);
        target.dispatchEvent(evt);
        this.interacted = true;
    };
    DataComponent.prototype.onRowChanged = function (row, toggle) {
        if (toggle === void 0) { toggle = false; }
        if (toggle) {
            if (!row.isSelected) {
                this.gridApi.selection.selectRow(row.entity);
            }
            else {
                row.setSelected(false);
            }
        }
        this.selectedRow = row.isSelected === false ? null : row;
    };
    DataComponent.prototype.setWatchers = function () {
        var _this = this;
        this.$scope.$watch('view.selectedRow.entity', function (newVal) {
            if (_this.editor && _this.selectedRow) {
                _this.editor.setValue(_this.selectedRow.entity);
            }
            _this.$timeout(function () {
                if (_this.gridApi) {
                    _this.gridApi.core.handleWindowResize();
                    // Handle resize after animation too
                    _this.$timeout(function () {
                        _this.gridApi.core.handleWindowResize();
                    }, 300);
                }
            }, 1);
            _this.interacted = false;
        });
        this.$scope.$on('ui.layout.resize', function () {
            _this.$timeout(function () {
                _this.gridApi.core.handleWindowResize();
            }, 1);
        });
        this.$scope.$watch('view.activeModel.name', function (newVal) {
            if (newVal) {
                _this.query = [];
                _this.$stateParams.type = newVal;
                _this.$state.go(_this.$state.current.name, _this.$stateParams, { notify: false, reload: false });
                _this.$location.replace();
            }
        });
        // TODO: model schema
        this.$scope.$watch('view.activeModel', function (newVal) {
            var editable = !Boolean(newVal && newVal.uiOptions && newVal.uiOptions.editable === false);
            _this.gridOptions.enableRowSelection = editable;
        });
        var firstLoad = true;
        this.$scope.$watch('view.selectedRow.entity.id', function (newVal) {
            if (newVal || !firstLoad) {
                _this.$stateParams.id = newVal;
                _this.$state.go(_this.$state.current.name, _this.$stateParams, { notify: false, reload: false });
                _this.$location.replace();
            }
            firstLoad = false;
        });
    };
    DataComponent.prototype.promptDeleteModel = function (name, properties) {
        var _this = this;
        this
            .$ionicPopup
            .confirm({
            title: 'Are you sure you want to PERMANENTLY delete this item?',
            okType: 'button-assertive'
        })
            .then(function (answer) {
            if (answer) {
                _this.deleteModel(name, properties);
            }
        });
    };
    DataComponent.prototype.deleteModel = function (name, properties) {
        var _this = this;
        this.$ionicLoading.show();
        return this
            .data
            .deleteModel(name, properties)
            .then(function () {
            _this.selectedRow = null;
            _this.notifySaved();
            return _this.refresh();
        });
    };
    DataComponent.prototype.saveEditingModel = function (model, options) {
        var _this = this;
        var method = model ? 'put' : 'post';
        this.interacted = false;
        // TODO: use smaller loading
        this.$ionicLoading.show();
        if (this.modal) {
            this.modal.remove();
        }
        var index;
        if (model) {
            index = this.gridOptions.data.indexOf(model);
        }
        return this
            .data[(method + "ModelData")](this.activeModel.name, model ? this.selectedRow.entity : options || this.modelValues)
            .then(function (response) {
            if (!model) {
                _this.onRowChanged({ entity: _.extend(response.data, options) });
            }
            _this.$ionicLoading.hide();
            _this.notifySaved();
        });
    };
    DataComponent.prototype.reload = function () {
        var _this = this;
        this.$ionicLoading.show();
        return this
            .fetchModelData(this.activeModel.name)
            .finally(function () {
            _this.$ionicLoading.hide();
        });
    };
    DataComponent.prototype.refresh = function () {
        var _this = this;
        this.$ionicLoading.show();
        return this
            .loadModel(this.activeModel.name)
            .finally(function () {
            _this.$ionicLoading.hide();
        });
    };
    DataComponent.prototype.createNewComponent = function (options) {
        var _this = this;
        this
            .saveEditingModel(null, options || {
            template: 'largeTitleHero',
            templateOptions: {},
            targetingRules: []
        })
            .then(function () {
            _this.refresh();
        });
    };
    DataComponent.prototype.showEditModal = function (properties) {
        var _this = this;
        this
            .saveEditingModel()
            .then(function () {
            return _this.refresh();
        }).then(function () {
            // TODO: use selectRow instead
            _this.gridApi.selection.selectRowByVisibleIndex(_this.gridOptions.data.length - 1);
            _this.gridApi.cellNav.scrollToFocus(_this.selectedRow.entity);
        });
    };
    DataComponent.prototype.fetchModelData = function (modelName) {
        var _this = this;
        var query = this.data.getLoopbackWhereFilterFromQuery(this.query);
        var filter = query.where.and.length ? query : {};
        _.extend(filter, {
            limit: this.limit,
            skip: this.offset * this.limit,
            order: this.order,
        });
        var config = {
            params: {
                filter: JSON.stringify(filter)
            }
        };
        var countConfig = { params: {} };
        if (query.where.and.length) {
            countConfig.params.where = JSON.stringify(query.where);
        }
        this
            .$http
            .get("/api/v1/" + this.activeModel.name + "s/count", countConfig)
            .then(function (response) {
            _this.gridOptions.totalItems = response.data.count;
        });
        return this
            .data
            .getModelData(modelName, config)
            .then(function (response) {
            _this.gridOptions.data = response.data;
        });
    };
    DataComponent.prototype.loadModel = function (name, refresh) {
        var _this = this;
        if (refresh === void 0) { refresh = false; }
        this.activeModel = this.models[name];
        this.modelSchema = this.data.modelToJsonSchema(this.activeModel);
        this.modelValues = {};
        // this.$ionicLoading.show();
        this.selectedRow = null;
        this.order = null;
        this.offset = 0;
        // Set column definitionsf
        this.gridOptions.columnDefs = this.data.mapColumnDefs(this.activeModel);
        if (refresh) {
            this.gridOptions.data = [];
            this.loading = true;
        }
        return this
            .fetchModelData(this.activeModel.name)
            .then(function () {
            // this.$ionicLoading.hide();
            _this.loading = false;
        });
    };
    DataComponent.prototype.downloadCsv = function () {
        this.gridApi.exporter.csvExport('all', 'all', document.createElement('div'));
    };
    DataComponent.prototype.getModels = function () {
        var _this = this;
        // get list of models
        return this
            .data
            .getModels()
            .then(function (models) {
            var promises = [];
            // for each model get the model JSON value
            models.forEach(function (model) {
                var promise = _this
                    .data
                    .getModel(model)
                    .then(function (response) {
                    _this.models[model] = response.data;
                });
                promises.push(promise);
            });
            // When all promises are complete set the first model as the active one
            return _this
                .$q
                .all(promises)
                .then(function () {
                _this.modelsList = _.sortBy(_.values(_this.models), 'name');
            });
        });
    };
    __decorate([
        inject_1.inject, 
        __metadata('design:type', data_service_1.Data)
    ], DataComponent.prototype, "data", void 0);
    __decorate([
        inject_1.inject, 
        __metadata('design:type', Object)
    ], DataComponent.prototype, "toastr", void 0);
    __decorate([
        inject_1.inject, 
        __metadata('design:type', Function)
    ], DataComponent.prototype, "$http", void 0);
    __decorate([
        inject_1.inject, 
        __metadata('design:type', Object)
    ], DataComponent.prototype, "$q", void 0);
    __decorate([
        inject_1.inject, 
        __metadata('design:type', Object)
    ], DataComponent.prototype, "$scope", void 0);
    __decorate([
        inject_1.inject, 
        __metadata('design:type', Object)
    ], DataComponent.prototype, "$state", void 0);
    __decorate([
        inject_1.inject, 
        __metadata('design:type', Object)
    ], DataComponent.prototype, "$location", void 0);
    __decorate([
        inject_1.inject, 
        __metadata('design:type', Object)
    ], DataComponent.prototype, "$ionicLoading", void 0);
    __decorate([
        inject_1.inject, 
        __metadata('design:type', Function)
    ], DataComponent.prototype, "$timeout", void 0);
    __decorate([
        inject_1.inject, 
        __metadata('design:type', Object)
    ], DataComponent.prototype, "$ionicPopup", void 0);
    __decorate([
        inject_1.inject, 
        __metadata('design:type', Object)
    ], DataComponent.prototype, "$stateParams", void 0);
    DataComponent = __decorate([
        hot_reload_1.HotReload(module),
        component_1.Component({
            selector: 'data'
        }),
        view_1.View({
            template: require('./data.html')
        }), 
        __metadata('design:paramtypes', [])
    ], DataComponent);
    return DataComponent;
})();
exports.DataComponent = DataComponent;
