var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var service_1 = require('../../scripts/decorators/service');
var inject_1 = require('../../scripts/decorators/inject');
var Data = (function () {
    function Data() {
    }
    Data.noop = function () {
        // do nothing
    };
    // TODO: multiple values? (ORs)
    Data.prototype.getLoopbackWhereFilterFromQuery = function (query) {
        var filter = {
            where: {
                and: query
                    .filter(function (item) {
                    return !_.isUndefined(item.property) && !_.isUndefined(item.value);
                })
                    .map(function (item) {
                    var obj = {};
                    var value;
                    var escaped;
                    switch (item.operator) {
                        case 'is':
                            value = item.value;
                            break;
                        case 'is not':
                            value = { neq: item.value };
                            break;
                        case 'is greater than':
                            value = { gt: item.value };
                            break;
                        case 'is less than':
                            value = { lt: item.value };
                            break;
                        case 'contains':
                            escaped = _.escapeRegExp(item.value);
                            value = { regexp: "/.*" + escaped + ".*/i" };
                            break;
                        default:
                            break;
                    }
                    obj[item.property] = value;
                    return obj;
                })
            }
        };
        return filter;
    };
    // TODO: boolean to humanize schema keys (?)
    Data.prototype.modelToJsonSchema = function (model) {
        var schema = _.cloneDeep(model);
        schema.title = schema.name;
        schema.type = 'object';
        // TODO: make recrusive
        for (var key in schema.properties) {
            if (key[0] === '$') {
                delete schema.properties[key];
                continue;
            }
            var value = schema.properties[key];
            // JSON editor wants date/datetimes as type: 'string', format: 'date' (or 'datetime' or 'datetime-local')
            if (_.contains(value.type, 'date')) {
                value.format = value.format || value.type;
                value.type = 'string';
            }
            if (_.isArray(value.type)) {
                var type = value.type;
                value.type = 'array';
                value.items = {
                    type: type,
                    propperties: {}
                };
            }
        }
        return schema;
    };
    // TODO: call findOne
    Data.prototype.getModelDataById = function (modelName, id) {
        return this
            .$http
            .get("/api/v1/" + modelName + "s/" + id);
    };
    Data.prototype.createColumnDef = function (value, key, parentKey, model) {
        if (parentKey === void 0) { parentKey = ''; }
        if (model === void 0) { model = {}; }
        var modelEditable = !Boolean(model.uiOptions && model.uiOptions.editable === false);
        return {
            // TODO: what loopback model prop should determine this
            enableCellEdit: modelEditable && _.contains(['string', 'date', 'datetime-local', 'number', 'boolean'], value.type),
            field: parentKey ? parentKey + "." + key : key,
            displayName: _.startCase(((parentKey || '') + " " + key).trim()),
            type: _.contains(value.format, 'date') // contains 'date' is for date, datetime, datetime-local
                ? value.format
                : value.type,
            editDropdownOptionsArray: value.enum ? value.enum.map(function (option) {
                return {
                    id: option,
                    value: option
                };
            }) : null,
            editDropdownFilter: 'titleize',
            cellFilter: value.format === 'datetime-local'
                ? 'date: "short"'
                : value.format === 'date' || value.type === 'date'
                    ? 'date: "shortDate"'
                    : null,
            editableCellTemplate: value.enum
                ? 'ui-grid/dropdownEditor'
                : value.options && value.options.upload
                    ? 'ui-grid/fileChooserEditor'
                    : value.format === 'datetime-local'
                        ? "\n          <div>\n            <form name=\"inputForm\">\n              <input\n                type=\"datetime-local\"\n                ng-class=\"'colt' + col.uid\"\n                ui-grid-editor\n                ng-model=\"MODEL_COL_FIELD\">\n            </form>\n          </div>\n        "
                        : null,
            editFileChooserCallback: value.options && value.options.upload ? this.uploadFile.bind(this) : null,
            minWidth: 150
        };
    };
    // Convert loopback model to ui.grid column definitions
    Data.prototype.mapColumnDefs = function (model) {
        var columnDefs = [];
        var modelEditable = !Boolean(model.uiOptions && model.uiOptions.editable === false);
        // if (modelEditable) {
        columnDefs.push({
            pinnedLeft: true,
            name: ' ',
            width: 50,
            enableCellEdit: false,
            cellTemplate: "\n        <div class=\"grid-edit-button-container\">\n          <button\n            ng-class=\"{ active: row.isSelected }\"\n            class=\"button grid-edit-button button-small button-outline button-clear button-positive\"\n            ng-click=\"grid.exporter.$scope.view.onRowChanged(row, true)\">\n            <!-- <i class=\"ion-edit\"></i> -->\n            " + (modelEditable ? 'Edit' : 'View') + "\n          </button>\n        </div>\n      "
        });
        // }
        for (var key in model.properties) {
            var value = model.properties[key];
            if (value.type === 'object' && value.properties) {
                for (var propKey in value.properties) {
                    columnDefs.push(this.createColumnDef(value.properties[propKey], propKey, key, model));
                }
            }
            else {
                columnDefs.push(this.createColumnDef(value, key, null, model));
            }
        }
        return columnDefs;
    };
    Data.prototype.uploadFile = function (gridRow, gridCol, files) {
        // TODO: better way of getting $http service
        // maybe move this to run block instead of config
        var $http = this.$http;
        var $ionicLoading = this.$ionicLoading;
        var formData = new FormData();
        var file = files[0];
        // TODO: real UUID
        var randomInt = Math.random().toString().split('.')[1];
        var fileExtension = _.last(file.name.split('.'));
        var now = Date.now();
        var filename = now + "-" + randomInt + "." + fileExtension;
        formData.append('file', file, filename);
        var bucketName = 'cmsstatic.shopstyle.com';
        $ionicLoading.show();
        $http
            .post("/api/v1/fileUploads/" + bucketName + "/upload", formData, {
            transformRequest: angular.identity,
            headers: { 'Content-Type': undefined }
        })
            .success(function (data) {
            $ionicLoading.hide();
            // TODO: save row
            gridRow.entity[gridCol.name] = "https://cms.shopstyle.com/assets/uploads/" + filename;
        });
    };
    // TODO: call findAll
    // TODO: method to get plural name for models
    // TODO: use ngResource for all this stuff?
    Data.prototype.getModelData = function (modelName, config) {
        if (config === void 0) { config = {}; }
        return this
            .$http
            .get("/api/v1/" + modelName + "s", config);
    };
    Data.prototype.putModelData = function (modelName, properties, config) {
        if (config === void 0) { config = {}; }
        return this
            .$http
            .put("/api/v1/" + modelName + "s/" + properties.id, properties, config);
    };
    Data.prototype.postModelData = function (modelName, properties, config) {
        if (config === void 0) { config = {}; }
        return this
            .$http
            .post("/api/v1/" + modelName + "s", properties, config);
    };
    Data.prototype.deleteModel = function (modelName, properties, config) {
        if (config === void 0) { config = {}; }
        return this
            .$http
            .delete("/api/v1/" + modelName + "s/" + properties.id, config);
    };
    Data.prototype.getModels = function () {
        return this
            .$http
            .get('/api/v1/localFiles/models/files')
            .then(function (response) {
            var data = response.data;
            return data
                .filter(function (file) {
                return !Boolean(file.name.match(/\.js$|file/));
            })
                .map(function (file) {
                return _.camelCase(file.name.replace(/\.json$/, ''));
            });
        });
    };
    Data.prototype.getModel = function (name) {
        return this
            .$http
            .get("/api/v1/localFiles/models/download/" + encodeURIComponent(_.kebabCase(name)) + ".json");
    };
    __decorate([
        inject_1.inject, 
        __metadata('design:type', Function)
    ], Data.prototype, "$http", void 0);
    __decorate([
        inject_1.inject, 
        __metadata('design:type', Object)
    ], Data.prototype, "$ionicLoading", void 0);
    Data = __decorate([
        service_1.Service('data'), 
        __metadata('design:paramtypes', [])
    ], Data);
    return Data;
})();
exports.Data = Data;
