var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
require('@host');
require('./generate.scss');
var component_1 = require('../../scripts/decorators/component');
var view_1 = require('../../scripts/decorators/view');
var inject_1 = require('../../scripts/decorators/inject');
var generate_1 = require('./generate');
var GenerateComponent = (function () {
    function GenerateComponent() {
        // TODO: interface for loopback models
        this.models = {};
        this.getModels();
    }
    GenerateComponent.prototype.loadModel = function (name) {
        this.activeModel = this.models[name];
        this.values = {};
        this.modelFields = this.generate.modelToFormDefinition(this.activeModel);
    };
    GenerateComponent.prototype.getModels = function () {
        var _this = this;
        // get list of models
        this
            .generate
            .getModels()
            .then(function (models) {
            var promises = [];
            // for each model get the model JSON value
            models.forEach(function (model) {
                var promise = _this
                    .generate
                    .getModel(model)
                    .then(function (response) {
                    _this.models[model] = response.data;
                });
                promises.push(promise);
            });
            // When all promises are complete set the first model as the active one
            _this
                .$q
                .all(promises)
                .then(function () {
                for (var key in _this.models) {
                    _this.loadModel(key);
                    break;
                }
            });
        });
    };
    __decorate([
        inject_1.inject, 
        __metadata('design:type', generate_1.Generate)
    ], GenerateComponent.prototype, "generate", void 0);
    __decorate([
        inject_1.inject, 
        __metadata('design:type', Object)
    ], GenerateComponent.prototype, "$q", void 0);
    GenerateComponent = __decorate([
        component_1.Component({
            selector: 'generate'
        }),
        view_1.View({
            template: require('./generate.html')
        }), 
        __metadata('design:paramtypes', [])
    ], GenerateComponent);
    return GenerateComponent;
})();
exports.GenerateComponent = GenerateComponent;
