var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
require('@host');
require('./login.scss');
var hot_reload_1 = require('../../scripts/decorators/hot-reload');
var component_1 = require('../../scripts/decorators/component');
var view_1 = require('../../scripts/decorators/view');
var inject_1 = require('../../scripts/decorators/inject');
var user_1 = require('../../scripts/services/user/user');
// directives
require('./error-messages/error-messages-component');
require('./form-field/form-field-component');
require('./disclosure/disclosure-component');
require('./social-auth-buttons/social-auth-buttons-component');
var LoginComponent = (function () {
    function LoginComponent() {
        this.method = angular.isDefined(this.method) ? this.method : 'signup';
        this.usernamePlaceholder = this.method === 'signup' ? 'Email' : 'Username or Email';
        this.username = this.user.data && (this.user.data.handle || this.user.data.email);
    }
    LoginComponent.prototype.switchMethod = function (state) {
        this.method = state;
        this.usernamePlaceholder = state === 'login' ? 'Username or Email' : 'Email';
    };
    LoginComponent.prototype.auth = function (authMethod) {
        var _this = this;
        this.$ionicLoading.show();
        var method = authMethod || this.method;
        var loginCall = (method === 'signup' || method === 'login') ?
            this.user[method](this.username, this.password) :
            this.user[method]();
        loginCall
            .then(this.authSuccess.bind(this))
            .catch(this.authFailure.bind(this))
            .finally(function () {
            _this.$ionicLoading.hide();
        });
    };
    LoginComponent.prototype.authSuccess = function () {
        var args = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            args[_i - 0] = arguments[_i];
        }
        if (this.onSuccess) {
            this.onSuccess.apply(null, args);
        }
    };
    LoginComponent.prototype.authFailure = function () {
        var args = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            args[_i - 0] = arguments[_i];
        }
        this.rejection = args[0].data || args[0];
        if (!this.rejection.errorMessage) {
            this.rejection.errorMessage = 'An unexpected error occured.';
        }
        if (this.onError) {
            this.onError.apply(null, args);
        }
    };
    LoginComponent.prototype.showAlert = function (title) {
        this.$ionicPopup.alert({
            title: title
        });
    };
    LoginComponent.prototype.forgotPassword = function () {
        var _this = this;
        // Request Method:POST
        this.$ionicPopup.prompt({
            title: 'Forgot Password',
            template: 'We\'ll send you a link to reset your password',
            inputType: 'email',
            inputPlaceholder: 'Email Address',
            cssClass: 'forgot-password'
        })
            .then(function (email) {
            if (email) {
                _this
                    .user
                    .forgotPassword(email)
                    .catch(function (response) {
                    if (response.status >= 400) {
                        _this.showAlert(response.data.errorMessage);
                    }
                });
            }
        });
    };
    __decorate([
        inject_1.inject, 
        __metadata('design:type', Object)
    ], LoginComponent.prototype, "$ionicLoading", void 0);
    __decorate([
        inject_1.inject, 
        __metadata('design:type', Object)
    ], LoginComponent.prototype, "$ionicPopup", void 0);
    __decorate([
        inject_1.inject, 
        __metadata('design:type', user_1.User)
    ], LoginComponent.prototype, "user", void 0);
    LoginComponent = __decorate([
        hot_reload_1.HotReload(module),
        component_1.Component({
            selector: 'login',
            bind: {
                socialAuth: '=',
                method: '@',
                onSuccess: '&',
                onError: '&'
            }
        }),
        view_1.View({
            template: require('./login.html')
        }), 
        __metadata('design:paramtypes', [])
    ], LoginComponent);
    return LoginComponent;
})();
exports.LoginComponent = LoginComponent;
