var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
require('./query-editor.scss');
var hot_reload_1 = require('../../scripts/decorators/hot-reload');
var component_1 = require('../../scripts/decorators/component');
var view_1 = require('../../scripts/decorators/view');
var inject_1 = require('../../scripts/decorators/inject');
var object_1 = require('../../scripts/constants/utils/object');
var query_editor_service_1 = require('./query-editor.service');
var QueryEditorComponent = (function () {
    function QueryEditorComponent() {
        var _this = this;
        this.bindWatchers();
        // TODO: setting to auto save or not
        // TODO: maybe parent should run this instead
        this.debouncedRun = _.debounce(function () {
            _this.onRun();
        }, 500);
    }
    QueryEditorComponent.prototype.bindWatchers = function () {
        var _this = this;
        this.$scope.$watch('view.model', function (newVal) {
            _this.propertyChoices = _this
                .queryEditor
                .getPropertyChoicesFromModel(_this.model);
            _this.flatModel = _this.queryEditor.flattenModel(newVal);
        });
        this.$scope.$watch('view.query', function (newVal) {
            if (newVal) {
                if (!newVal.length || !_.isUndefined(_.last(newVal).value)) {
                    _this.addQuery();
                }
                var secondToLastItem = newVal[newVal.length - 2];
                if (secondToLastItem && !_.isUndefined(secondToLastItem.value)) {
                    _this.debouncedRun();
                }
            }
        }, true);
    };
    QueryEditorComponent.prototype.removeQuery = function (query) {
        this.objectUtils.remove(this.query, query);
    };
    QueryEditorComponent.prototype.addQuery = function (properties) {
        if (properties === void 0) { properties = {}; }
        this.query.push(_.defaults(properties, {
            operator: 'contains'
        }));
    };
    __decorate([
        inject_1.inject, 
        __metadata('design:type', query_editor_service_1.QueryEditor)
    ], QueryEditorComponent.prototype, "queryEditor", void 0);
    __decorate([
        inject_1.inject, 
        __metadata('design:type', object_1.ObjectUtils)
    ], QueryEditorComponent.prototype, "objectUtils", void 0);
    __decorate([
        inject_1.inject, 
        __metadata('design:type', Object)
    ], QueryEditorComponent.prototype, "$scope", void 0);
    QueryEditorComponent = __decorate([
        hot_reload_1.HotReload(module),
        component_1.Component({
            selector: 'query-editor',
            bind: {
                query: '=',
                model: '=',
                onRun: '&'
            }
        }),
        view_1.View({
            template: require('./query-editor.html')
        }), 
        __metadata('design:paramtypes', [])
    ], QueryEditorComponent);
    return QueryEditorComponent;
})();
exports.QueryEditorComponent = QueryEditorComponent;
