var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var service_1 = require('../../scripts/decorators/service');
var QueryEditor = (function () {
    function QueryEditor() {
        // TODO: different by type
        this.operatorChoices = {
            string: [
                'contains',
                'is',
                'is not',
            ],
            number: [
                'is',
                'is not',
                'is greater than',
                'is less than'
            ],
            date: [
                'is',
                'is not',
                'is greater than',
                'is less than',
                'contains',
            ],
            boolean: [
                'is'
            ],
        };
    }
    QueryEditor.prototype.getPropertyChoicesFromModel = function (model) {
        var arr = [];
        if (model && model.properties) {
            for (var key in model.properties) {
                var value = model.properties[key];
                if (typeof value === 'object' && value.properties) {
                    for (var propKey in value.properties) {
                        arr.push(key + "." + propKey);
                    }
                }
                else {
                    arr.push(key);
                }
            }
        }
        return arr;
    };
    QueryEditor.prototype.flattenModel = function (model) {
        var flatModel = {};
        if (model && model.properties) {
            for (var key in model.properties) {
                var value = model.properties[key];
                flatModel[key] = value;
                if (typeof value === 'object' && value.properties) {
                    for (var propKey in value.properties) {
                        flatModel[(key + "." + propKey)] = value.properties[propKey];
                    }
                }
            }
        }
        return flatModel;
    };
    QueryEditor = __decorate([
        service_1.Service('queryEditor'), 
        __metadata('design:paramtypes', [])
    ], QueryEditor);
    return QueryEditor;
})();
exports.QueryEditor = QueryEditor;
