/**
 * AutoRegister
 *
 * Auto register angular modules that are loaded so all you have to do is
 * import them as needed and don't need to manually add angular dependencies
 *
 * tl;dr you don't ever have to do angular.module 'app', [...stuff], instead
 * just
 *
 * 		import 'what-you-want';
 *
 * and any angular modules imported are automatically loaded for you as
 * a dependency of your application
 *
 * @todo move to node module / bower component
 */
export declare class AutoRegister {
    private modules;
    private appModuleName;
    constructor(appModuleName?: string);
    /**
     * Register our main application module that everything gets bound to
     */
    private registerModule();
    /**
     * Stub angular.module to listen to registered modules
     * and automatically register them for the app module
     */
    private stubModuleFunction();
}
declare var _default: AutoRegister;
export default _default;
