export declare class ObjectUtils {
    /**
     * Remove an item from an array and return the supplied array
     *
     * @todo move to array utils
     *
     * @param  {Array} arr   Array to remove the item from
     * @param  {any}   item  Item to remove from the array
     * @return {Array}       The array supplied, now with the given item removed
     */
    remove(arr: any[], item: any): any[];
    /**
     * Remove all key/value pairs from an object or array
     *
     * @param  {Object|any[]} obj
     * Object to clear
     *
     * @return {Object}           Originally supplied object
     */
    clear(obj: any): any;
    /**
     * Replace all keys/values of one object/array with another
     * but keep the reference to the original
     *
     * @param  {Object|any[]} obj1
     * Source object to clear and extend with the second
     *
     * @param  {Object|any[]} obj2
     * New object to extend all key/values to the source
     *
     * @return {Object|any[]}
     *  Modified source object supplied
     */
    replace(obj1: any, obj2: any): any;
    /**
     * Recursively removes any undefined values from an object.
     */
    prune(object: any): any;
    /**
     *  Flatten an object, e.g.
     *
     *   from { user: { name: 'steve' } }
     *   to   { 'user.name': 'steve' }
     *
     * Credit: http://stackoverflow.com/a/19101235
     *  */
    flatten(object: any, flattenArrays?: boolean): {};
}
