var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var constant_1 = require('../../decorators/constant');
var _ = require('lodash');
var ObjectUtils = (function () {
    function ObjectUtils() {
    }
    /**
     * Remove an item from an array and return the supplied array
     *
     * @todo move to array utils
     *
     * @param  {Array} arr   Array to remove the item from
     * @param  {any}   item  Item to remove from the array
     * @return {Array}       The array supplied, now with the given item removed
     */
    ObjectUtils.prototype.remove = function (arr, item) {
        var index = 0;
        while (index !== -1) {
            index = arr.indexOf(item, index);
            if (index !== -1) {
                arr.splice(index, 1);
            }
        }
        return arr;
    };
    /**
     * Remove all key/value pairs from an object or array
     *
     * @param  {Object|any[]} obj
     * Object to clear
     *
     * @return {Object}           Originally supplied object
     */
    ObjectUtils.prototype.clear = function (obj) {
        // Arrays
        if (_.isArray(obj)) {
            obj.length = 0;
        }
        // Objects
        for (var key in obj) {
            delete obj[key];
        }
        return obj;
    };
    /**
     * Replace all keys/values of one object/array with another
     * but keep the reference to the original
     *
     * @param  {Object|any[]} obj1
     * Source object to clear and extend with the second
     *
     * @param  {Object|any[]} obj2
     * New object to extend all key/values to the source
     *
     * @return {Object|any[]}
     *  Modified source object supplied
     */
    ObjectUtils.prototype.replace = function (obj1, obj2) {
        this.clear(obj1);
        return _.extend(obj1, obj2);
    };
    /**
     * Recursively removes any undefined values from an object.
     */
    ObjectUtils.prototype.prune = function (object) {
        var _this = this;
        _.forEach(object, function (value, key) {
            if (_.isObject(value)) {
                value = object[key] = _this.prune(value);
            }
            if (!(_.isBoolean(value) || _.isNumber(value)) && _.isEmpty(value)) {
                delete object[key];
            }
        });
        return object;
    };
    /**
     *  Flatten an object, e.g.
     *
     *   from { user: { name: 'steve' } }
     *   to   { 'user.name': 'steve' }
     *
     * Credit: http://stackoverflow.com/a/19101235
     *  */
    ObjectUtils.prototype.flatten = function (object, flattenArrays) {
        if (flattenArrays === void 0) { flattenArrays = true; }
        var result = {};
        var recurse = function (cur, prop) {
            if (Object(cur) !== cur) {
                result[prop] = cur;
            }
            else if (Array.isArray(cur)) {
                if (flattenArrays) {
                    var i = 0;
                    var l = cur.length;
                    while (i < l) {
                        recurse(cur[i], prop + '[' + i + ']');
                        i++;
                    }
                    if (l === 0) {
                        result[prop] = [];
                    }
                    else {
                        result[prop] = cur;
                    }
                }
            }
            else {
                var isEmpty = true;
                for (var p in cur) {
                    isEmpty = false;
                    recurse(cur[p], prop ? prop + '.' + p : p);
                    if (isEmpty && prop) {
                        result[prop] = {};
                    }
                }
            }
        };
        recurse(object, '');
        return result;
    };
    ObjectUtils = __decorate([
        constant_1.Constant('objectUtils', true), 
        __metadata('design:paramtypes', [])
    ], ObjectUtils);
    return ObjectUtils;
})();
exports.ObjectUtils = ObjectUtils;
