// import * as _             from 'lodash';
var inject_1 = require('./inject');
var object_1 = require('../constants/utils/object');
var objectUtils = new object_1.ObjectUtils();
var hotCache = {};
exports.Component = function (options) {
    var decorator = function (Target) {
        var name = options.name || options.selector;
        var dashName = _.kebabCase(name);
        var camelName = _.camelCase(name);
        var className = _.capitalize(camelName);
        var controllerName = className + "Controller";
        var viewOptions = _.find(Target.annotations, function (item) {
            return item.type === 'view';
        }) || {};
        options = _.clone(options);
        var defaultOptions = {
            selector: dashName,
            name: camelName,
            restrict: 'E',
            // TODO: allow provider for customizing this
            controllerAs: 'view',
            scope: {},
            bindToController: options.bind || {},
            controller: controllerName
        };
        _.defaults(options, defaultOptions, viewOptions.value);
        if (!Target.annotations) {
            Target.annotations = [];
        }
        // TODO: ensure component + controller all subclassable
        Target.annotations.push({
            type: 'component',
            decorator: exports.Component,
            value: options
        });
        var injectableOptions = [function () { return options; }];
        // TODO: put somewhere else
        var injectableTarget = inject_1.makeInjectable(Target, false);
        if (hotCache[name]) {
            objectUtils.replace(hotCache[name].injectableTarget, injectableTarget);
            _.extend(hotCache[name].options, options);
        }
        else {
            // Construct the module
            // TODO: allow link and other functions with imports for directives (?)
            angular
                .module('app')
                .directive(camelName, injectableOptions);
            angular
                .module('app')
                .controller(controllerName, injectableTarget);
            hotCache[name] = { injectableOptions: injectableOptions, injectableTarget: injectableTarget, options: options };
        }
        // TODO: do constants get replaced when defined a second time?
        angular
            .module('app')
            .constant(className + "Component", Target);
        return Target;
    };
    return decorator;
};
