var inject_1 = require('./inject');
/**
 * @decorator Config
 *
 * @type {ClassDecorator}
 *
 * @example
 *
 * ```ts
 * @Config
 * export class Routes {
 * 	 @inject
 * 	 private $stateProvider: angular.ui.IStateProvider;
 *
 * 		// Constructor takes no args for config
 * 		// classes
 * 		constructor() {
 * 			this.$stateProvider.state({
 * 			  // ...
 * 			});
 * 		}
 * }
 * ```
 */
exports.Config = function (Target) {
    var target = inject_1.makeInjectable(Target, false);
    // Construct the module
    angular
        .module('app')
        .config(target);
};
