/**
 * @decorator Controller
 * @description create angular controllers
 * @param {string} name     name of your controller
 * @type {Function}
 * @example
 * ```ts
 * @Controller('TodoController')
 * export class Router {
 *   @inject str: Str;
 *
 * 	myMethod(name: string) {
 * 		str.dasherize(name);
 * 	  // do stuff...
 * 	}
 * }
 * ```
 */
export declare const Controller: (name: string) => void;
