/**
 * @decorator Directive
 *
 * @description
 * create angular directives from classes
 *
 * @param {string} name
 * name of your directive
 *
 * @example
 * ```ts
 * @Directive('Router')
 * export class Router {
 *   @inject str: Str;
 *
 * 	link(element) {
 * 		str.dasherize(element.text());
 * 	  // do stuff...
 * 	}
 * }
 * ```
 */
export declare const Directive: (name: string) => <TFunction extends Function>(target: TFunction) => TFunction | void;
