var inject_1 = require('./inject');
/**
 * @decorator Directive
 *
 * @description
 * create angular directives from classes
 *
 * @param {string} name
 * name of your directive
 *
 * @example
 * ```ts
 * @Directive('Router')
 * export class Router {
 *   @inject str: Str;
 *
 * 	link(element) {
 * 		str.dasherize(element.text());
 * 	  // do stuff...
 * 	}
 * }
 * ```
 */
exports.Directive = function (name) {
    var decorator = function (Target) {
        var target = inject_1.makeInjectable(Target);
        // Construct the module
        angular
            .module('app')
            .directive(name, target);
    };
    return decorator;
};
