var inject_1 = require('./inject');
/**
 * @decorator Factory
 *
 * @description create angular services
 *
 * @param {string} name
 * name of your factory
 *
 * @example
 * ```ts
 * @Factory('abTests')
 * export class AbTests {
 *   @inject str: Str;
 *
 * 	 onstructor() {
 * 	   AbTests.str.dasherize('foo');
 * 	 }
 * }
 * ```
 */
exports.Factory = function (name) {
    var decorator = function (Target) {
        Target = inject_1.makeInjectable(Target, true);
        // Construct the module
        angular
            .module('app')
            .factory(name, Target);
    };
};
