var inject_1 = require('./inject');
/**
 * @decorator Service
 *
 * @description create angular services
 *
 * @param {string} name
 * name of your service
 *
 * @example
 * ```ts
 * @Service('abTests')
 * export class AbTests {
 *   @inject str: Str;
 *
 * 	 onstructor() {
 * 	   // do something...
 * 	   str.dasherize('foobar');
 * 	 }
 * }
 * ```
 */
exports.Provider = function (name) {
    var decorator = function (Target) {
        var target = inject_1.makeInjectable(Target, false);
        // Construct the module
        angular
            .module('app')
            .provider(name, target);
    };
    return decorator;
};
