/**
 * @decorator Run
 *
 * @type {ClassDecorator}
 *
 * @example
 * ```ts
 * @Run
 * export class Routes {
 * 	 @inject
 * 	 private $stateProvider: angular.ui.IStateProvider;
 *
 * 		// Constructor takes no args for config
 * 		// classes
 * 		constructor() {
 * 			this.$stateProvider.state({
 * 			  // ...
 * 			});
 * 		}
 * }
 * ```
 */
export declare const Run: ClassDecorator;
