/**
 * @decorator Service
 *
 * @description create angular services
 *
 * @param {string} name
 * name of your service
 *
 * @example
 * ```ts
 * @Service('abTests')
 * export class AbTests {
 *   @inject str: Str;
 *
 * 	 onstructor() {
 * 	   // do something...
 * 	   str.dasherize('foobar');
 * 	 }
 * }
 * ```
 */
export declare const Service: (name: string) => <TFunction extends Function>(target: TFunction) => TFunction | void;
