var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
require('../dependencies/app');
var inject_1 = require('../../scripts/decorators/inject');
var url_1 = require('../../scripts/constants/utils/url');
var interceptor_1 = require('../../scripts/decorators/interceptor');
var DigestGenerator = require('@ssjs/node-shopstyle-auth-digest-generator');
var digestGenerator = new DigestGenerator();
var AuthorizationInterceptor = (function () {
    function AuthorizationInterceptor() {
    }
    AuthorizationInterceptor.prototype.request = function (requestConfig) {
        var user = this.$cookies.getObject('userData');
        if (this.isApiCall(requestConfig.url)) {
            requestConfig.params = requestConfig.params || {};
            // put any default params (like pid) in config.defaultRequestParams
            _.defaults(requestConfig.params, this.config.defaultRequestParams);
            var method = requestConfig.method;
            // Remove query parameters from the url
            if (requestConfig.url.indexOf('?') > -1) {
                // parse existing params from requestConfig.url
                _.assign(requestConfig.params, this.urlUtils.getQueryParams(requestConfig.url));
                // remove existing params from requestConfig.url
                requestConfig.url = requestConfig.url.split('?')[0];
            }
            // add debugging params if the debug flag is set in config
            if (this.config.authDebug) {
                requestConfig.params.authDebug = 1;
                requestConfig.params.includeStackTrace = 1;
            }
            // build the final URL for our digest
            var url = this.urlUtils.addParams(requestConfig.url, requestConfig.params);
            var a = document.createElement('a');
            a.href = url;
            url = a.pathname + a.search;
            var body;
            if (requestConfig.data) {
                body = JSON.parse(angular.toJson(requestConfig.data));
            }
            if (user && user.id) {
                var loginTimestamp = user.loginTimestamp;
                var secret = user.loginToken;
                var now = new Date();
                var request = digestGenerator.createRequest(method, url, body);
                var digest = digestGenerator.generateDigest(request, now.toUTCString(), secret);
                requestConfig.headers.Authorization = 'PopSugar userId=' + user.id + ', ' +
                    'loginTimestamp=' + loginTimestamp + ', digest=' + digest +
                    ', version=0';
                requestConfig.headers['Authorization-Date'] = now.toUTCString();
            }
            return requestConfig;
        }
        return requestConfig;
    };
    ;
    AuthorizationInterceptor.prototype.responseError = function (rejection) {
        if (rejection.status === 401) {
            this.$cookies.remove('userData');
            this.$location.path('/');
        }
        return this.$q(function (resolve, reject) {
            reject(rejection);
        });
    };
    ;
    AuthorizationInterceptor.prototype.isApiCall = function (url) {
        // if the request is relative (starts with a //), or if it contains
        // 'shopstyle', then we know it's an API request and should be authenticated
        var apiRegex = /^\/\/|shopstyle/;
        return apiRegex.test(url);
    };
    __decorate([
        inject_1.inject,
        __metadata('design:type', Object)
    ], AuthorizationInterceptor.prototype, "$cookies", void 0);
    __decorate([
        inject_1.inject,
        __metadata('design:type', Object)
    ], AuthorizationInterceptor.prototype, "$location", void 0);
    __decorate([
        inject_1.inject,
        __metadata('design:type', Object)
    ], AuthorizationInterceptor.prototype, "$q", void 0);
    __decorate([
        inject_1.inject,
        __metadata('design:type', url_1.UrlUtils)
    ], AuthorizationInterceptor.prototype, "urlUtils", void 0);
    __decorate([
        inject_1.inject,
        __metadata('design:type', Object)
    ], AuthorizationInterceptor.prototype, "config", void 0);
    AuthorizationInterceptor = __decorate([
        interceptor_1.Interceptor,
        __metadata('design:paramtypes', [])
    ], AuthorizationInterceptor);
    return AuthorizationInterceptor;
})();
exports.AuthorizationInterceptor = AuthorizationInterceptor;
