var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var service_1 = require('../decorators/service');
var inject_1 = require('../decorators/inject');
var component_1 = require('../services/component');
var _ = require('lodash');
var Modal = (function () {
    function Modal() {
    }
    Modal.prototype.show = function (viewName, viewOptions, modalOptions) {
        if (viewOptions === void 0) { viewOptions = {}; }
        if (modalOptions === void 0) { modalOptions = {}; }
        var camelName = _.camelCase(viewName);
        var template = this.template(camelName, viewOptions);
        var scope = modalOptions.scope || this.$rootScope.$new();
        _.defaults(modalOptions, {
            className: _.kebabCase(viewName) + '-modal'
        });
        _.assign(scope, viewOptions);
        var modal = scope.modal = this.$ionicModal.fromTemplate(template, modalOptions);
        modal.show();
        return modal;
    };
    // TODO: move to directive
    Modal.prototype.template = function (name, options) {
        if (options === void 0) { options = {}; }
        var componentTemplate = this.component.template(name, options);
        var titleName = options && options.title || _.startCase(name);
        var className = options && options.className || '';
        // TODO: allow overridable with config / config provider
        var viewTemplate = "\n      <ion-modal-view class=\"" + className + "\">\n        <ion-header-bar>\n          <h1 class=\"title\">\n            " + titleName + "\n          </h1>\n          <button class=\"button button-clear\" ng-click=\"modal.hide()\">\n            Close\n          </button>\n        </ion-header-bar>\n        <ion-content>\n          " + componentTemplate + "\n        </ion-content>\n      </ion-modal-view>\n    ";
        return viewTemplate;
    };
    __decorate([
        inject_1.inject, 
        __metadata('design:type', Object)
    ], Modal.prototype, "$ionicModal", void 0);
    __decorate([
        inject_1.inject, 
        __metadata('design:type', Object)
    ], Modal.prototype, "$rootScope", void 0);
    __decorate([
        inject_1.inject, 
        __metadata('design:type', component_1.Component)
    ], Modal.prototype, "component", void 0);
    Modal = __decorate([
        service_1.Service('modal'), 
        __metadata('design:paramtypes', [])
    ], Modal);
    return Modal;
})();
exports.Modal = Modal;
