var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var service_1 = require('../decorators/service');
var inject_1 = require('../decorators/inject');
var component_1 = require('../services/component');
var _ = require('lodash');
var Popover = (function () {
    function Popover() {
    }
    Popover.prototype.show = function (viewName, event, viewOptions, popoverOptions) {
        if (viewOptions === void 0) { viewOptions = {}; }
        if (popoverOptions === void 0) { popoverOptions = {}; }
        var camelName = _.camelCase(viewName);
        var template = this.template(camelName, viewOptions);
        var scope = popoverOptions.scope || this.$rootScope.$new();
        var popover = scope.popover = this
            .$ionicPopover
            .fromTemplate(template, popoverOptions);
        popover.show(event);
        return popover;
    };
    Popover.prototype.template = function (name, options) {
        if (options === void 0) { options = {}; }
        var template = this.component.template(name, options);
        var titleName = options.title || _.startCase(name);
        var popoverTemplate = "\n      <ion-popover-view>\n        <ion-header-bar>\n          <h1 class=\"title\">\n            " + titleName + "\n          </h1>\n        </ion-header-bar>\n        <ion-content>\n          " + template + "\n        </ion-content>\n      </ion-popover-view>\n    ";
        return popoverTemplate;
    };
    __decorate([
        inject_1.inject, 
        __metadata('design:type', Object)
    ], Popover.prototype, "$rootScope", void 0);
    __decorate([
        inject_1.inject, 
        __metadata('design:type', Object)
    ], Popover.prototype, "$ionicPopover", void 0);
    __decorate([
        inject_1.inject, 
        __metadata('design:type', component_1.Component)
    ], Popover.prototype, "component", void 0);
    Popover = __decorate([
        service_1.Service('popover'), 
        __metadata('design:paramtypes', [])
    ], Popover);
    return Popover;
})();
exports.Popover = Popover;
