var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
require('@host');
var service_1 = require('../../decorators/service');
var inject_1 = require('../../decorators/inject');
require('angular-easyfb');
require('./login-config');
var gapi = require('./gapi-client');
var User = (function () {
    function User() {
        this.data = this.$cookies.getObject('userData');
        if (!this.data) {
            return;
        }
        else if (this.data.loginTimestamp && this.data.loginToken) {
            this.data.$isLoggedIn = true;
        }
    }
    Object.defineProperty(User.prototype, "isLoggedIn", {
        get: function () {
            return Boolean(this.data && this.data.$isLoggedIn);
        },
        enumerable: true,
        configurable: true
    });
    User.prototype.signup = function (username, password, options) {
        var _this = this;
        var deferred = this.$q.defer();
        if (this.data && this.data.$isLoggedIn) {
            deferred.resolve();
            return deferred.promise.then(function () {
                return _this.data;
            });
        }
        var data = {
            password: password
        };
        if (this.isValidEmail(username)) {
            data.email = username;
        }
        else {
            deferred.reject({
                errorMessage: 'Invalid email address'
            });
            return deferred.promise;
        }
        var params = {
            format: 'json',
            includeCookie: true,
            track: false,
            ugcCounts: true
        };
        var signUpUrl = this.config.secureApiRoot + "/api/v2/users";
        return this
            .$http
            .post(signUpUrl, data, { params: params })
            .then(function (response) {
            return _this
                .checkLoginApiResponse(response)
                .then(function (loginResponse) {
                _this.successfulAuth(loginResponse);
                return loginResponse;
            })
                .catch(function (err) {
                deferred.reject(err);
                return _this.$q.reject(err);
            });
        });
    };
    User.prototype.login = function (username, password, options) {
        var _this = this;
        var deferred = this.$q.defer();
        if (this.data && this.data.$isLoggedIn) {
            deferred.resolve();
            return deferred.promise.then(function () {
                return _this.data;
            });
        }
        var data = {
            password: password
        };
        if (this.isValidEmail(username)) {
            data.email = username;
        }
        else {
            data.handle = username;
        }
        var params = {
            format: 'json',
            includeCookie: true,
            track: false,
            ugcCounts: true
        };
        var loginApiUrl = this.config.secureApiRoot + "/api/v2/login";
        return this
            .$http
            .post(loginApiUrl, data, { params: params })
            .then(function (response) {
            return _this
                .checkLoginApiResponse(response)
                .then(function (loginResponse) {
                _this.successfulAuth(loginResponse);
                return loginResponse;
            })
                .catch(function (err) {
                deferred.reject(err);
                return _this.$q.reject(err);
            });
        });
    };
    User.prototype.facebookLogin = function () {
        var _this = this;
        var deferred = this.$q.defer();
        this
            .ezfb
            .login(function (response) {
            if (!response || !response.authResponse || !response.authResponse.accessToken) {
                var error = new Error('Something went wrong, please try again.');
                deferred.reject(error);
                return _this.$q.reject(error);
            }
            var data = {
                accessToken: response.authResponse.accessToken
            };
            var params = {
                format: 'json',
                includeCookie: true,
                track: false
            };
            return _this
                .$http
                .post(_this.config.secureApiRoot + "/api/v2/login/facebook", data, { params: params })
                .then(function (loginResponse) {
                return _this
                    .checkLoginApiResponse(loginResponse)
                    .then(function (apiResponse) {
                    _this.successfulAuth(apiResponse);
                    deferred.resolve(apiResponse);
                    return apiResponse;
                })
                    .catch(function (err) {
                    deferred.reject(err);
                    return _this.$q.reject(err);
                });
            });
        }, { scope: 'email' });
        return deferred.promise;
    };
    User.prototype.googleLogin = function () {
        var _this = this;
        var self = this;
        var deferred = this.$q.defer();
        gapi.auth.authorize({
            client_id: '334881074383.apps.googleusercontent.com',
            scope: 'https://www.googleapis.com/auth/plus.login https://www.googleapis.com/auth/userinfo.email',
            fetch_basic_profile: true,
            response_type: 'code token'
        }, function (authResult) {
            if (!authResult || authResult.error || authResult instanceof Error) {
                deferred.reject(authResult);
                return _this.$q.reject(authResult);
            }
            else {
                var data = {
                    code: authResult.code
                };
                var params = {
                    format: 'json',
                    includeCookie: true,
                    track: false,
                    ugcCounts: true
                };
                self
                    .$http
                    .post(_this.config.secureApiRoot + "/api/v2/login/google", data, { params: params })
                    .then(function (apiResponse) {
                    self.successfulAuth(apiResponse);
                    deferred.resolve(apiResponse);
                    return apiResponse;
                })
                    .catch(function (err) {
                    deferred.reject(err);
                    return _this.$q.reject(err);
                });
            }
        });
        return deferred.promise;
    };
    User.prototype.checkLoginApiResponse = function (response) {
        var deferred = this.$q.defer();
        if (!response || response.status >= 400 || !response.data) {
            deferred.reject(response);
        }
        else {
            deferred.resolve(response);
        }
        return deferred.promise;
    };
    User.prototype.successfulAuth = function (response) {
        var userResponse = response.data.user;
        _.extend(userResponse, {
            $isLoggedIn: true,
            loginTimestamp: response.data.loginTimestamp,
            loginToken: response.data.loginToken
        });
        this.updateCookie(userResponse);
        this.$rootScope.$broadcast('user.shopstyleAuthSuccess', this.data);
    };
    User.prototype.updateCookie = function (userData) {
        // TODO: should we store in localstorage?
        //
        var cookieWhitelist = [
            'apiKey',
            'authLevel',
            'email',
            'handle',
            'id',
            'authentication',
            'type',
            'loginTimestamp',
            'loginToken',
            'paypalEmail',
            'paypalFirstName',
            'paypalLastName'
        ];
        if (this.data) {
            _.extend(this.data, userData);
        }
        else {
            this.data = userData;
        }
        this.$cookies.putObject('userData', _.pick(this.data, cookieWhitelist), { domain: this.config.tld });
    };
    User.prototype.put = function (newFields) {
        var _this = this;
        var userUrl = this.config.apiRoot + "/api/v2/users/" + this.data.id;
        return this.$http.put(userUrl, newFields).then(function () {
            _this.updateCookie(newFields);
            return _this;
        });
    };
    User.prototype.logOut = function (noReload) {
        this.$cookies.remove('userData', { domain: this.config.tld });
        this.$cookies.remove('userAuthorized', { domain: this.config.tld });
        this.referrer = null;
        this.data.$isLoggedIn = false;
        this.data = null;
        // TODO: for some reason the state is not changing when logout, this is a quick fix
        if (!noReload) {
            window.location.href = window.location.origin;
        }
    };
    ;
    User.prototype.forgotPassword = function (email) {
        var params = {
            format: 'json',
            track: false,
            includeCookie: true,
            ugcCounts: true,
            email: email
        };
        var url = this.config.apiRoot + "login/sendResetPasswordEmail";
        return this.$http.post(url, {}, { params: params });
    };
    User.prototype.isValidEmail = function (email) {
        var regExp = /^[-0-9a-zA-Z.+_]+@[-0-9a-zA-Z.+_]+\.[a-zA-Z]{2,4}$/;
        return regExp.test(email);
    };
    __decorate([
        inject_1.inject, 
        __metadata('design:type', Object)
    ], User.prototype, "$q", void 0);
    __decorate([
        inject_1.inject, 
        __metadata('design:type', Object)
    ], User.prototype, "$rootScope", void 0);
    __decorate([
        inject_1.inject, 
        __metadata('design:type', Object)
    ], User.prototype, "$cookies", void 0);
    __decorate([
        inject_1.inject, 
        __metadata('design:type', Function)
    ], User.prototype, "$http", void 0);
    __decorate([
        inject_1.inject, 
        __metadata('design:type', Object)
    ], User.prototype, "config", void 0);
    __decorate([
        inject_1.inject, 
        __metadata('design:type', Object)
    ], User.prototype, "ezfb", void 0);
    User = __decorate([
        service_1.Service('user'), 
        __metadata('design:paramtypes', [])
    ], User);
    return User;
})();
exports.User = User;
