declare module '@ssjs/shopstyle-node-common/dist/client/components/api-composer/api-composer-component' {
  import { ApiComposer } from '@ssjs/shopstyle-node-common/dist/client/components/api-composer/api-composer';
  export class ApiComposerComponent {
      apiComposer: ApiComposer;
      constructor();
  }

}

declare module '@ssjs/shopstyle-node-common/dist/client/components/api-composer/api-composer' {
  export class ApiComposer {
  }

}

declare module '@ssjs/shopstyle-node-common/dist/client/components/api-docs/api-docs-component' {
  import { ApiDocs } from '@ssjs/shopstyle-node-common/dist/client/components/api-docs/api-docs';
  export class ApiDocsComponent {
      apiDocs: ApiDocs;
      private docsUrl;
      constructor();
      iframeLoaded(event: Event): void;
  }

}

declare module '@ssjs/shopstyle-node-common/dist/client/components/api-docs/api-docs' {
  export class ApiDocs {
      docUrls: {
          prod: string;
          qa: string;
      };
  }

}

declare module '@ssjs/shopstyle-node-common/dist/client/components/app/app-component' {
  import { App } from '@ssjs/shopstyle-node-common/dist/client/components/app/app';
  export class AppComponent {
      app: App;
      $rootScope: any;
      constructor();
      ionicGoBack(): void;
  }

}

declare module '@ssjs/shopstyle-node-common/dist/client/components/app/app' {
  export class App {
  }

}

declare module '@ssjs/shopstyle-node-common/dist/client/components/body/body-component' {
  import { Body } from '@ssjs/shopstyle-node-common/dist/client/components/body/body';
  export class BodyComponent {
      body: Body;
      constructor();
  }

}

declare module '@ssjs/shopstyle-node-common/dist/client/components/body/body' {
  export class Body {
  }

}

declare module '@ssjs/shopstyle-node-common/dist/client/components/coverage/coverage-component' {
  import { Coverage } from '@ssjs/shopstyle-node-common/dist/client/components/coverage/coverage';
  export class CoverageComponent {
      coverage: Coverage;
  }

}

declare module '@ssjs/shopstyle-node-common/dist/client/components/coverage/coverage' {
  export class Coverage {
  }

}

declare module '@ssjs/shopstyle-node-common/dist/client/components/data/data-component' {
  export class DataComponent {
      private data;
      private toastr;
      private $http;
      private $q;
      private $scope;
      private $state;
      private $location;
      private $ionicLoading;
      private $timeout;
      private $ionicPopup;
      private $stateParams;
      models: {
          [name: string]: any;
      };
      modelFields: Array<AngularFormly.IFieldConfigurationObject>;
      modelSchema: any;
      optionsTabs: string[];
      optionsTab: string;
      activeModel: any;
      values: any;
      gridApi: any;
      modelValues: any;
      selectedRow: any;
      chartData: any;
      modal: any;
      editor: any;
      codeEditor: any;
      limit: number;
      offset: number;
      order: string;
      loading: boolean;
      query: any[];
      interacted: boolean;
      gridOptions: any;
      modelsList: any[];
      constructor();
      notifySaved(): void;
      editorInit(scope: any): void;
      codeEditorInit(scope: any): void;
      onJsonEditorChange(value: any): void;
      onCodeEditorChange(value: any): void;
      cloneActiveModel(): void;
      /**
       * Hack to submit updates on every keypress.
       * @todo there has to be a better way built-in
       */
      onEditorKeypress(event: Event): void;
      onRowChanged(row: any, toggle?: boolean): void;
      setWatchers(): void;
      promptDeleteModel(name: string, properties: any): void;
      deleteModel(name: string, properties: any): ng.IPromise<{}>;
      saveEditingModel(model?: any, options?: any): any;
      reload(): ng.IPromise<{}>;
      refresh(): ng.IPromise<{}>;
      createNewComponent(options?: any): void;
      showEditModal(properties: any): void;
      fetchModelData(modelName: string): ng.IPromise<void>;
      loadModel(name: string, refresh?: boolean): ng.IPromise<void>;
      downloadCsv(): void;
      getModels(): ng.IPromise<void>;
  }

}

declare module '@ssjs/shopstyle-node-common/dist/client/components/data/data-service' {
  export class Data {
      private $http;
      private $ionicLoading;
      static noop(): void;
      getLoopbackWhereFilterFromQuery(query: any[]): {
          where: {
              and: {}[];
          };
      };
      modelToJsonSchema(model: any): any;
      getModelDataById(modelName: string, id: string): ng.IHttpPromise<{}>;
      createColumnDef(value: any, key: string, parentKey?: string, model?: any): {
          enableCellEdit: boolean;
          field: string;
          displayName: string;
          type: any;
          editDropdownOptionsArray: any;
          editDropdownFilter: string;
          cellFilter: string;
          editableCellTemplate: string;
          editFileChooserCallback: any;
          minWidth: number;
      };
      mapColumnDefs(model: any): any[];
      uploadFile(gridRow: any, gridCol: any, files: File[]): void;
      getModelData(modelName: string, config?: any): ng.IHttpPromise<{}>;
      putModelData(modelName: string, properties: any, config?: any): ng.IHttpPromise<{}>;
      postModelData(modelName: string, properties: any, config?: any): ng.IHttpPromise<{}>;
      deleteModel(modelName: string, properties: any, config?: any): ng.IHttpPromise<{}>;
      getModels(): ng.IPromise<string[]>;
      getModel(name: string): ng.IHttpPromise<{}>;
  }

}

declare module '@ssjs/shopstyle-node-common/dist/client/components/developer/developer-component' {
  import { Developer } from '@ssjs/shopstyle-node-common/dist/client/components/developer/developer-service';
  export class DocsComponent {
      developer: Developer;
  }

}

declare module '@ssjs/shopstyle-node-common/dist/client/components/developer/developer-service' {
  export class Developer {
  }

}

declare module '@ssjs/shopstyle-node-common/dist/client/components/docs/docs-component' {
  import { Docs } from '@ssjs/shopstyle-node-common/dist/client/components/docs/docs';
  export class DocsComponent {
      docs: Docs;
  }

}

declare module '@ssjs/shopstyle-node-common/dist/client/components/docs/docs' {
  export class Docs {
  }

}

declare module '@ssjs/shopstyle-node-common/dist/client/components/generate/generate-component' {
  export class GenerateComponent {
      private generate;
      private $q;
      models: {
          [name: string]: any;
      };
      modelFields: Array<AngularFormly.IFieldConfigurationObject>;
      activeModel: any;
      values: any;
      constructor();
      loadModel(name: string): void;
      getModels(): void;
  }

}

declare module '@ssjs/shopstyle-node-common/dist/client/components/generate/generate' {
  export class Generate {
      private $http;
      modelToFormDefinition(model: any): AngularFormly.IFieldConfigurationObject[];
      getModels(): ng.IPromise<string[]>;
      getModel(name: string): ng.IHttpPromise<{}>;
  }

}

declare module '@ssjs/shopstyle-node-common/dist/client/components/head/head-component' {
  import { Head } from '@ssjs/shopstyle-node-common/dist/client/components/head/head-service';
  export class HeadComponent {
      head: Head;
  }

}

declare module '@ssjs/shopstyle-node-common/dist/client/components/head/head-service' {
  export class Head {
      private $rootScope;
      tagDefaults: {
          description: string;
      };
      tags: any;
      meta: {
          description: string;
          viewport: string;
      };
      constructor();
      resetMetaTags(): void;
      title(): string;
      resetTags(): {};
      set(options: any): {};
  }

}

declare module '@ssjs/shopstyle-node-common/dist/client/components/login/disclosure/disclosure-component' {
  export class Disclosure {
  }

}

declare module '@ssjs/shopstyle-node-common/dist/client/components/login/error-messages/error-messages-component' {
  export class ErrorMessages {
      rejection: any;
  }

}

declare module '@ssjs/shopstyle-node-common/dist/client/components/login/form-field/form-field-component' {
  export class FormField {
  }

}

declare module '@ssjs/shopstyle-node-common/dist/client/components/login/login-component' {
  import { User } from '@ssjs/shopstyle-node-common/dist/client/scripts/services/user/user';
  export class LoginComponent {
      private $ionicLoading;
      private $ionicPopup;
      user: User;
      usernamePlaceholder: string;
      method: string;
      socialAuth: boolean;
      username: string;
      password: string;
      rejection: any;
      onSuccess: any;
      onError: any;
      constructor();
      switchMethod(state: string): void;
      auth(authMethod: string): void;
      private authSuccess(...args);
      private authFailure(...args);
      showAlert(title: string): void;
      forgotPassword(): void;
  }

}

declare module '@ssjs/shopstyle-node-common/dist/client/components/login/login-service' {
  export class Login {
  }

}

declare module '@ssjs/shopstyle-node-common/dist/client/components/login/social-auth-buttons/social-auth-buttons-component' {
  export class SocialAuthButtons {
      facebookClick: any;
      googleClick: any;
      buttonClick(type: string): void;
  }

}

declare module '@ssjs/shopstyle-node-common/dist/client/components/query-editor/query-editor.component' {
  import { ObjectUtils } from '@ssjs/shopstyle-node-common/dist/client/scripts/constants/utils/object';
  import { QueryEditor, IQuery } from '@ssjs/shopstyle-node-common/dist/client/components/query-editor/query-editor.service';
  export class QueryEditorComponent {
      queryEditor: QueryEditor;
      objectUtils: ObjectUtils;
      $scope: angular.IScope;
      query: IQuery[];
      onRun: Function;
      debouncedRun: Function;
      propertyChoices: string[];
      flatModel: {
          [id: string]: any;
      };
      model: any;
      constructor();
      bindWatchers(): void;
      removeQuery(query: IQuery): void;
      addQuery(properties?: IQuery): void;
  }

}

declare module '@ssjs/shopstyle-node-common/dist/client/components/query-editor/query-editor.service' {
  export interface IQuery {
      property?: string;
      value?: string;
      operator?: string;
  }
  export class QueryEditor {
      operatorChoices: {
          string: string[];
          number: string[];
          date: string[];
          boolean: string[];
      };
      getPropertyChoicesFromModel(model: any): any[];
      flattenModel(model: any): {};
  }

}

declare module '@ssjs/shopstyle-node-common/dist/client/components/side-menu/side-menu-component' {
  export class CoverageComponent {
      private modal;
      private $state;
      states: ng.ui.IState[];
      constructor();
  }

}

declare module '@ssjs/shopstyle-node-common/dist/client/index' {
  /// <reference path="../../typings/tsd.d.ts" />

}

declare module '@ssjs/shopstyle-node-common/dist/client/scripts/auto-register' {
  /**
   * AutoRegister
   *
   * Auto register angular modules that are loaded so all you have to do is
   * import them as needed and don't need to manually add angular dependencies
   *
   * tl;dr you don't ever have to do angular.module 'app', [...stuff], instead
   * just
   *
   * 		import 'what-you-want';
   *
   * and any angular modules imported are automatically loaded for you as
   * a dependency of your application
   *
   * @todo move to node module / bower component
   */
  export class AutoRegister {
      private modules;
      private appModuleName;
      constructor(appModuleName?: string);
      /**
       * Register our main application module that everything gets bound to
       */
      private registerModule();
      /**
       * Stub angular.module to listen to registered modules
       * and automatically register them for the app module
       */
      private stubModuleFunction();
  }
  var _default: AutoRegister;
  export default _default;

}

declare module '@ssjs/shopstyle-node-common/dist/client/scripts/config/compile' {
  export class CompileConfigs {
      $compileProvider: angular.ICompileProvider;
      $httpProvider: angular.IHttpProvider;
      $provide: any;
      config: any;
      constructor();
      /**
       * Set location configs
       */
      setConfigs(): void;
  }

}

declare module '@ssjs/shopstyle-node-common/dist/client/scripts/config/ionic' {
  export class FormlyConfigs {
      private $ionicConfigProvider;
      constructor();
      /**
       * Set ionic configs
       */
      setConfigs(): void;
  }

}

declare module '@ssjs/shopstyle-node-common/dist/client/scripts/config/json-editor' {
  export class JsonEditorSettings {
      JSONEditorProvider: any;
      constructor();
      addDateType(): void;
      addUploadHandler(): void;
      addUploadEditor(): void;
      setAcePluginConfigs(): void;
      setProviderConfigs(): void;
      createIconLib(): void;
      createTheme(): void;
  }

}

declare module '@ssjs/shopstyle-node-common/dist/client/scripts/config/location' {
  export class LocationConfigs {
      $locationProvider: angular.ILocationProvider;
      constructor();
      /**
       * Set location configs
       */
      setConfigs(): void;
  }

}

declare module '@ssjs/shopstyle-node-common/dist/client/scripts/config/routes' {
  import { Router } from '@ssjs/shopstyle-node-common/dist/client/scripts/providers/router';
  export class Routes extends Router {
      config: any;
      defaultRoute: any;
      routes: any;
      constructor();
  }

}

declare module '@ssjs/shopstyle-node-common/dist/client/scripts/config/sce' {
  export class SceConfigs {
      $sceDelegateProvider: angular.ISCEDelegateProvider;
      constructor();
      /**
       * Set location configs
       */
      setConfigs(): void;
  }

}

declare module '@ssjs/shopstyle-node-common/dist/client/scripts/config/ui-select' {
  export class UiSelectConfigs {
      uiSelectConfig: any;
      constructor();
      /**
       * Set ionic configs
       */
      setConfigs(): void;
  }

}

declare module '@ssjs/shopstyle-node-common/dist/client/scripts/constants/device' {
  export const device: {};

}

declare module '@ssjs/shopstyle-node-common/dist/client/scripts/constants/ionic-loading' {
  export class IonicLoadingConfig {
      template: string;
      noBackdrop: boolean;
  }

}

declare module '@ssjs/shopstyle-node-common/dist/client/scripts/constants/lodash' {
  import * as _ from 'lodash';
  export default _;

}

declare module '@ssjs/shopstyle-node-common/dist/client/scripts/constants/utils/array' {
  export class ArrayUtils {
  }

}

declare module '@ssjs/shopstyle-node-common/dist/client/scripts/constants/utils/number' {
  export class NumberUtils {
      /**
       * Pretty format a number.
       *
       * @example
       * numberUtils.prettyFormat(5100000);
       * // returns '5.1M'
       *
       * @param  {number} value Number to convert
       * @return {string}       String of converted number
       */
      prettyFormat(value: number): string;
  }

}

declare module '@ssjs/shopstyle-node-common/dist/client/scripts/constants/utils/object' {
  export class ObjectUtils {
      /**
       * Remove an item from an array and return the supplied array
       *
       * @todo move to array utils
       *
       * @param  {Array} arr   Array to remove the item from
       * @param  {any}   item  Item to remove from the array
       * @return {Array}       The array supplied, now with the given item removed
       */
      remove(arr: any[], item: any): any[];
      /**
       * Remove all key/value pairs from an object or array
       *
       * @param  {Object|any[]} obj
       * Object to clear
       *
       * @return {Object}           Originally supplied object
       */
      clear(obj: any): any;
      /**
       * Replace all keys/values of one object/array with another
       * but keep the reference to the original
       *
       * @param  {Object|any[]} obj1
       * Source object to clear and extend with the second
       *
       * @param  {Object|any[]} obj2
       * New object to extend all key/values to the source
       *
       * @return {Object|any[]}
       *  Modified source object supplied
       */
      replace(obj1: any, obj2: any): any;
      /**
       * Recursively removes any undefined values from an object.
       */
      prune(object: any): any;
      /**
       *  Flatten an object, e.g.
       *
       *   from { user: { name: 'steve' } }
       *   to   { 'user.name': 'steve' }
       *
       * Credit: http://stackoverflow.com/a/19101235
       *  */
      flatten(object: any, flattenArrays?: boolean): {};
  }

}

declare module '@ssjs/shopstyle-node-common/dist/client/scripts/constants/utils/string' {
  export class StringUtils {
      humanize(str?: string): string;
  }

}

declare module '@ssjs/shopstyle-node-common/dist/client/scripts/constants/utils/tests/object.spec' {

}

declare module '@ssjs/shopstyle-node-common/dist/client/scripts/constants/utils/url' {
  export class UrlUtils {
      /**
       * Encode and add a param to a url
       *
       * @example
       * ```ts
       * urlUtils.addParam('foo.com', 'foo', 'b a r');
       * // returns 'foo.com?foo=b%20a%20r'
       *
       * utils.addParam('foo.com?already=hasParams', 'foo', 'b a r');
       * // returns 'foo.com?already=hasParams&foo=b%20a%20r'
       * ```
       *
       * @param  {string} url   Url to add param to
       * @param  {string} name  Param key
       * @param  {string} value Param value
       * @return {string}       Newly const ructed url
       */
      addParam(url: string, name: string, value: string): string;
      /**
       * Encode a URI compoent angular style
       */
      encodeURIComponent(str: string): string;
      /**
       * Parse query params from a URL string
       */
      getQueryParams(url: string): {};
      /**
       * Encodes and adds a map of param names/values sorting them
       * alphabetically for consistent cache keys
       *
       * @example
       * ```ts
       * urlUtils.addParams('foo.com', {
       * 	 foo: 'bar',
       * 	 list: ['a', 'b', 'c']
       * });
       * // returns 'foo.com?foo=bar&list=a&list=b&list=c'
       * ```
       *
       * @param  {string} url      Start URL
       * @param  {any}    paramMap Map of params to add
       * @return {string}          New URL
       */
      addParams(url: string, paramMap: any): string;
      /**
       * Generates the absolute path for a url when
       * it is within a cordova app. Necessary because
       * lazy loading/webpack messes with how cordova usually
       * does this automatically.
      */
      getAbsolutePathForCordova(url?: string): string;
      parseUrl(url: string): {
          href: string;
          protocol: string;
          host: string;
          port: string;
          path: string;
          search: string;
          query: any;
      };
  }

}

declare module '@ssjs/shopstyle-node-common/dist/client/scripts/decorators/component' {
  export interface IComponentOptions extends angular.IDirective {
      selector?: string;
      bind?: any;
      wrapTemplate?: boolean;
  }
  export const Component: (options: IComponentOptions) => <TFunction extends Function>(target: TFunction) => TFunction | void;

}

declare module '@ssjs/shopstyle-node-common/dist/client/scripts/decorators/config' {
  /**
   * @decorator Config
   *
   * @type {ClassDecorator}
   *
   * @example
   *
   * ```ts
   * @Config
   * export class Routes {
   * 	 @inject
   * 	 private $stateProvider: angular.ui.IStateProvider;
   *
   * 		// Constructor takes no args for config
   * 		// classes
   * 		constructor() {
   * 			this.$stateProvider.state({
   * 			  // ...
   * 			});
   * 		}
   * }
   * ```
   */
  export const Config: ClassDecorator;

}

declare module '@ssjs/shopstyle-node-common/dist/client/scripts/decorators/constant' {
  /**
   * @decorator Constant
   * @description create and set angular constants
   * @param {string} name           name of constant to set
   * @param {string} createInstance create an instance of this class and set
   * that as the config value
   * @type {Function}
   * @example
   * ```ts
   * @Constant('Router')
   * export class Router {
   *   // ...
   * }
   * ```
   */
  export const Constant: (name: string, createInstance?: boolean) => (target: any) => void;

}

declare module '@ssjs/shopstyle-node-common/dist/client/scripts/decorators/controller' {
  /**
   * @decorator Controller
   * @description create angular controllers
   * @param {string} name     name of your controller
   * @type {Function}
   * @example
   * ```ts
   * @Controller('TodoController')
   * export class Router {
   *   @inject str: Str;
   *
   * 	myMethod(name: string) {
   * 		str.dasherize(name);
   * 	  // do stuff...
   * 	}
   * }
   * ```
   */
  export const Controller: (name: string) => void;

}

declare module '@ssjs/shopstyle-node-common/dist/client/scripts/decorators/directive' {
  /**
   * @decorator Directive
   *
   * @description
   * create angular directives from classes
   *
   * @param {string} name
   * name of your directive
   *
   * @example
   * ```ts
   * @Directive('Router')
   * export class Router {
   *   @inject str: Str;
   *
   * 	link(element) {
   * 		str.dasherize(element.text());
   * 	  // do stuff...
   * 	}
   * }
   * ```
   */
  export const Directive: (name: string) => <TFunction extends Function>(target: TFunction) => TFunction | void;

}

declare module '@ssjs/shopstyle-node-common/dist/client/scripts/decorators/factory' {
  /**
   * @decorator Factory
   *
   * @description create angular services
   *
   * @param {string} name
   * name of your factory
   *
   * @example
   * ```ts
   * @Factory('abTests')
   * export class AbTests {
   *   @inject str: Str;
   *
   * 	 onstructor() {
   * 	   AbTests.str.dasherize('foo');
   * 	 }
   * }
   * ```
   */
  export const Factory: (name: string) => void;

}

declare module '@ssjs/shopstyle-node-common/dist/client/scripts/decorators/filter' {
  export const Filter: (name: string) => <TFunction extends Function>(target: TFunction) => TFunction | void;

}

declare module '@ssjs/shopstyle-node-common/dist/client/scripts/decorators/hot-reload' {
  export const HotReload: (componentModule: any) => <TFunction extends Function>(target: TFunction) => TFunction | void;

}

declare module '@ssjs/shopstyle-node-common/dist/client/scripts/decorators/inject' {
  /**
   * @decorator inject
   *
   * @type {PropertyDecorator}
   *
   * @todo Allow this to take options like @inject('name') so can alias?
   */
  export const inject: PropertyDecorator;
  /**
   * Make a class angular injectable
   *
   * @param {any}     Target
   * @param {boolean} createInstance  Should an instance of this class be created
   *
   * @todo: find a better place for this
   * @todo: make a class or decorator that is subclassed or used on decorator?
   */
  export const makeInjectable: (Target: any, createInstance?: boolean, bindContext?: boolean) => any[];

}

declare module '@ssjs/shopstyle-node-common/dist/client/scripts/decorators/interceptor' {
  /**
   * @decorator Config
   *
   * @type {ClassDecorator}
   *
   * @example
   *
   * ```ts
   * @Interceptor
   * export class Routes {
   * 	 @inject
   * 	 private someDependency: SomeDependency;
   *
   * 		// Constructor takes no args for config
   * 		// classes
   * 		request(config: angular.IRequestConfig) {
   * 			if (this.someDependency.foo()) {
   * 				config.params.bar = 'baz';
   * 			}
   * 		}
   * }
   * ```
   */
  export const Interceptor: ClassDecorator;

}

declare module '@ssjs/shopstyle-node-common/dist/client/scripts/decorators/provider' {
  /**
   * @decorator Service
   *
   * @description create angular services
   *
   * @param {string} name
   * name of your service
   *
   * @example
   * ```ts
   * @Service('abTests')
   * export class AbTests {
   *   @inject str: Str;
   *
   * 	 onstructor() {
   * 	   // do something...
   * 	   str.dasherize('foobar');
   * 	 }
   * }
   * ```
   */
  export const Provider: (name: string) => <TFunction extends Function>(target: TFunction) => TFunction | void;

}

declare module '@ssjs/shopstyle-node-common/dist/client/scripts/decorators/run' {
  /**
   * @decorator Run
   *
   * @type {ClassDecorator}
   *
   * @example
   * ```ts
   * @Run
   * export class Routes {
   * 	 @inject
   * 	 private $stateProvider: angular.ui.IStateProvider;
   *
   * 		// Constructor takes no args for config
   * 		// classes
   * 		constructor() {
   * 			this.$stateProvider.state({
   * 			  // ...
   * 			});
   * 		}
   * }
   * ```
   */
  export const Run: ClassDecorator;

}

declare module '@ssjs/shopstyle-node-common/dist/client/scripts/decorators/service' {
  /**
   * @decorator Service
   *
   * @description create angular services
   *
   * @param {string} name
   * name of your service
   *
   * @example
   * ```ts
   * @Service('abTests')
   * export class AbTests {
   *   @inject str: Str;
   *
   * 	 onstructor() {
   * 	   // do something...
   * 	   str.dasherize('foobar');
   * 	 }
   * }
   * ```
   */
  export const Service: (name: string) => <TFunction extends Function>(target: TFunction) => TFunction | void;

}

declare module '@ssjs/shopstyle-node-common/dist/client/scripts/decorators/state' {
  import { IState } from '@ssjs/shopstyle-node-common/dist/client/scripts/providers/router';
  /**
   * @decorator State
   *
   * @todo doc my params, description, and example
   */
  export const State: (stateConfig: IState) => <TFunction extends Function>(target: TFunction) => TFunction | void;

}

declare module '@ssjs/shopstyle-node-common/dist/client/scripts/decorators/view' {
  export interface IViewDecoratorOptions {
      templateUrl?: string;
      template?: string;
  }
  export const View: (options: IViewDecoratorOptions) => <TFunction extends Function>(target: TFunction) => TFunction | void;

}

declare module '@ssjs/shopstyle-node-common/dist/client/scripts/dependencies/ace' {

}

declare module '@ssjs/shopstyle-node-common/dist/client/scripts/dependencies/app' {
  export class App {
  }

}

declare module '@ssjs/shopstyle-node-common/dist/client/scripts/dependencies/chart-js' {

}

declare module '@ssjs/shopstyle-node-common/dist/client/scripts/dependencies/ionic' {

}

declare module '@ssjs/shopstyle-node-common/dist/client/scripts/dependencies/json-editor' {

}

declare module '@ssjs/shopstyle-node-common/dist/client/scripts/dependencies/pikaday' {

}

declare module '@ssjs/shopstyle-node-common/dist/client/scripts/dependencies/typings' {
  /// <reference path="../../../../typings/tsd.d.ts" />

}

declare module '@ssjs/shopstyle-node-common/dist/client/scripts/dependencies/ui-grid' {
  var _default: string;
  export = _default;

}

declare module '@ssjs/shopstyle-node-common/dist/client/scripts/dependencies/ui-select' {

}

declare module '@ssjs/shopstyle-node-common/dist/client/scripts/directives/active' {
  export class ActiveDirective implements angular.IDirective {
      link(scope: ng.IScope, element: ng.IAugmentedJQuery, attrs: any): void;
  }

}

declare module '@ssjs/shopstyle-node-common/dist/client/scripts/directives/bg-load-animation' {
  export class BgLoadAnimationDirective implements angular.IDirective {
      link(scope: ng.IScope, element: ng.IAugmentedJQuery, attrs: any): void;
  }

}

declare module '@ssjs/shopstyle-node-common/dist/client/scripts/directives/edit-json-text' {
  export class EditJsonTextDirective implements angular.IDirective {
      restrict: string;
      require: string;
      link(scope: ng.IScope, element: ng.IAugmentedJQuery, attr: ng.IAttributes, ngModel: ng.INgModelController): void;
  }

}

declare module '@ssjs/shopstyle-node-common/dist/client/scripts/directives/load-animation' {
  export class LoadAnimationDirective implements angular.IDirective {
      link(scope: ng.IScope, element: ng.IAugmentedJQuery, attrs: any): void;
  }

}

declare module '@ssjs/shopstyle-node-common/dist/client/scripts/directives/ng-model-suffix' {
  export class NgModelSuffixDirective implements angular.IDirective {
      restrict: string;
      require: string;
      scope: {
          ngModelSuffix: string;
      };
      link(scope: any, element: ng.IAugmentedJQuery, attr: ng.IAttributes, ngModel: ng.INgModelController): void;
  }

}

declare module '@ssjs/shopstyle-node-common/dist/client/scripts/directives/on-load' {
  export class OnLoadDirective implements angular.IDirective {
      link(scope: ng.IScope, element: ng.IAugmentedJQuery, attrs: any): void;
  }

}

declare module '@ssjs/shopstyle-node-common/dist/client/scripts/directives/pikaday' {
  export class PikadayDirective implements angular.IDirective {
      require: string;
      rectrict: string;
      scope: {
          date: string;
      };
      link(scope: any, element: ng.IAugmentedJQuery, attrs: any, ngModel: angular.INgModelController): void;
  }

}

declare module '@ssjs/shopstyle-node-common/dist/client/scripts/filters/humanize' {
  export class Humanize {
      constructor();
  }

}

declare module '@ssjs/shopstyle-node-common/dist/client/scripts/filters/titleize' {
  export class Titleize {
      constructor();
  }

}

declare module '@ssjs/shopstyle-node-common/dist/client/scripts/interceptors/authorization' {
  import { UrlUtils } from '@ssjs/shopstyle-node-common/dist/client/scripts/constants/utils/url';
  export class AuthorizationInterceptor {
      $cookies: angular.cookies.ICookiesService;
      $location: angular.ILocationService;
      $q: any;
      urlUtils: UrlUtils;
      config: any;
      request(requestConfig: angular.IRequestConfig): ng.IRequestConfig;
      responseError(rejection: any): any;
      private isApiCall(url);
  }

}

declare module '@ssjs/shopstyle-node-common/dist/client/scripts/providers/router' {
  /**
   * @interface IState
   * @extends angular.ui.IState
   * @description
   * Extends angular.ui.IState to support a comopnent property
   * that takes a component name and turns it into a template
   */
  export interface IState extends angular.ui.IState {
      component?: string;
      /**
       * If there is a component for this state, should it be
       * lazy loaed?
       *
       * @type {Boolean}
       * @default false
       */
      lazy?: Boolean;
      resolve?: any;
      attachToView?: string;
      wrapTemplate?: boolean;
      /**
       * Source module to find component
       * @example
       *   module: '@ssjs/shopstyle-components'
       */
      module?: string;
      /**
       * Path to component
       */
      path?: string;
      hideNavBar?: boolean;
  }
  export interface IRouterDefaults {
      /**
       * Default route to redirect to if no others match
       * @type {string}
       */
      defaultRoute: string;
      /**
       * List of states
       * @type {IState[]}
       * ```
       */
      routes: IState[];
      /**
       * String to prepend to all component state names. E.g.
       * with the default 'app' a component by the name 'home'
       * wil lhave the state name 'app.home'
       * @todo way to configure these as a provider
       * @default 'app'
       * @type {String}
       */
      componentStatePrefix: string;
      /**
       * Name of main ui-view. This is what is used
       * for the view name all components nest under.
       * E.g. for 'menuContent' component routes get const ructed as
       *
       * @type {String}
       * @default 'menuContent';
       */
      mainViewName: string;
  }
  export class Router implements IRouterDefaults {
      $stateProvider: angular.ui.IStateProvider;
      $urlRouterProvider: angular.ui.IUrlRouterProvider;
      componentStatePrefix: string;
      mainViewName: string;
      defaultRoute: string;
      routes: IState[];
      static noop(): void;
      constructor();
      /**
       * Set router defaults via IRouterDefaults interface
       *
       * @param {IRouterDefaults} options   Router defaults to set
       * @param {boolean}         defaults  Only set if not already set
       */
      set(options: IRouterDefaults, defaults?: boolean): void;
      $get(): Router;
      /**
       * Takes a state object and const ructs and applies the route
       * for it via $stateProvider.state()
       *
       * @param  {IState}    state  State object to apply
       * @return {ui.IState}        Converted state object (to angular.ui.IState format)
       */
      applyRoute(state: IState): angular.ui.IState;
      /**
       * Converts an IState to a angular.ui.IState
       *
       * @description
       * Note that any property can be overwritten, so you can
       * supply custom urls, views, component name, etc and the
       * 'component' property will fill in any missing fields
       *
       * @param  {IState} state  Default state object to conert
       * @return {ui.IState}     Converted state object
       *
       * @example
       * Converts
       * ```ts
       * { component: 'home' }
       * ```
       * to
       * ```ts
       * {
       * 	name: 'app.home',
       * 	url: '/home',
       * 	views: {
       * 		menuContent: {
       * 			template: ```
       * 				<ion-view title="Home">
       * 					<ion-content>
       * 						<home></home>
       * 					</ion-content>
       * 				</ion-view>
       * 			```
       * 		}
       * 	}
       * }
       * ```
       */
      configureState(state: IState): angular.ui.IState;
      /**
       * Apply routes configured via this.routes
       * @param {IState[]} routes List
       */
      applyRoutes(routes?: IState[]): void;
  }

}

declare module '@ssjs/shopstyle-node-common/dist/client/scripts/services/component' {
  export class Component {
      template(name: string, options?: any): string;
      viewTemplate(name: string, options?: any): string;
  }

}

declare module '@ssjs/shopstyle-node-common/dist/client/scripts/services/hot-reload' {
  export class HotReload {
      $compile: angular.ICompileService;
      /**
       * Find all instances on the current page of a component by
       * name and reload them
       *
       * @param  {string} componentName  Name of the compnoent to reload
       */
      reloadComponent(componentName: string): void;
  }

}

declare module '@ssjs/shopstyle-node-common/dist/client/scripts/services/lazy' {
  import { UrlUtils } from '@ssjs/shopstyle-node-common/dist/client/scripts/constants/utils/url';
  export class Lazy {
      $ocLazyLoad: oc.ILazyLoad;
      $ionicLoading: ionic.loading.IonicLoadingService;
      urlUtils: UrlUtils;
      $window: any;
      static noop(): void;
      load(name: string): ng.IPromise<void>;
  }

}

declare module '@ssjs/shopstyle-node-common/dist/client/scripts/services/modal' {
  export class Modal {
      private $ionicModal;
      private $rootScope;
      private component;
      show(viewName: string, viewOptions?: any, modalOptions?: ionic.modal.IonicModalOptions): ionic.modal.IonicModalController;
      template(name: string, options?: any): string;
  }

}

declare module '@ssjs/shopstyle-node-common/dist/client/scripts/services/popover' {
  import { Component } from '@ssjs/shopstyle-node-common/dist/client/scripts/services/component';
  export class Popover {
      $rootScope: angular.IRootScopeService;
      $ionicPopover: ionic.popover.IonicPopoverService;
      component: Component;
      show(viewName: string, event: MouseEvent, viewOptions?: any, popoverOptions?: ionic.popover.IonicPopoverOptions): ionic.popover.IonicPopoverController;
      template(name: string, options?: any): string;
  }

}

declare module '@ssjs/shopstyle-node-common/dist/client/scripts/services/screen' {
  export class Screen {
      $rootScope: angular.IRootScopeService;
      $window: angular.IWindowService;
      sm: boolean;
      md: boolean;
      lg: boolean;
      small: boolean;
      medium: boolean;
      large: boolean;
      size: string;
      constructor();
      private sizes;
      update(): void;
  }

}

declare module '@ssjs/shopstyle-node-common/dist/client/scripts/services/track' {

}

declare module '@ssjs/shopstyle-node-common/dist/client/scripts/services/user/login-config' {
  export class EasyfbConfig {
      ezfbProvider: any;
      private config;
      constructor();
  }

}

declare module '@ssjs/shopstyle-node-common/dist/client/scripts/services/user/user' {
  import { IUser } from '@ssjs/shopstyle-node-common/dist/common/interfaces/user';
  export class User {
      private $q;
      $rootScope: angular.IRootScopeService;
      private $cookies;
      private $http;
      private config;
      private ezfb;
      referrer: string;
      data: IUser;
      constructor();
      isLoggedIn: boolean;
      signup(username: string, password: string, options?: any): ng.IPromise<IUser>;
      login(username: string, password: string, options?: any): ng.IPromise<IUser>;
      facebookLogin(): ng.IPromise<{}>;
      googleLogin(): ng.IPromise<{}>;
      private checkLoginApiResponse(response);
      private successfulAuth(response);
      private updateCookie(userData);
      put(newFields: any): ng.IPromise<User>;
      logOut(noReload?: boolean): void;
      forgotPassword(email: string): ng.IHttpPromise<{}>;
      private isValidEmail(email);
  }

}

declare module '@ssjs/shopstyle-node-common/dist/common/interfaces/product' {
  export interface IMobile {
      url: string;
  }
  export interface IDefault {
      url: string;
  }
  export interface IFeatured {
      url: string;
  }
  export interface IMobile2x {
      url: string;
  }
  export interface IFeatured2x {
      url: string;
  }
  export interface IDefault2x {
      url: string;
  }
  export interface ISizes {
      mobile: IMobile;
      default: IDefault;
      featured: IFeatured;
      'mobile@2x': IMobile2x;
      'featured@2x': IFeatured2x;
      'default@2x': IDefault2x;
  }
  export interface ILogo {
      sizes: ISizes;
  }
  export interface IRetailer {
      id: string;
      name: string;
      logo: ILogo;
      userId: number;
      userHandle: string;
      userImage: string;
      urlIdentifier: string;
      favIcon: string;
      effectiveContentLocale: string;
      handle: string;
  }
  export interface IMobile2 {
      url: string;
  }
  export interface IDefault2 {
      url: string;
  }
  export interface IFeatured2 {
      url: string;
  }
  export interface IMobile2x2 {
      url: string;
  }
  export interface IFeatured2x2 {
      url: string;
  }
  export interface IDefault2x2 {
      url: string;
  }
  export interface ISizes2 {
      mobile: IMobile2;
      default: IDefault2;
      featured: IFeatured2;
      'mobile@2x': IMobile2x2;
      'featured@2x': IFeatured2x2;
      'default@2x': IDefault2x2;
  }
  export interface ILogo2 {
      sizes: ISizes2;
  }
  export interface IBrand {
      id: string;
      name: string;
      logo: ILogo2;
      userId: number;
      userHandle: string;
      userImage: string;
      urlIdentifier: string;
  }
  export interface ISmall {
      sizeName: string;
      url: string;
      width: number;
      height: number;
      actualWidth: number;
      actualHeight: number;
  }
  export interface IXLarge {
      sizeName: string;
      url: string;
      width: number;
      height: number;
      actualWidth: number;
      actualHeight: number;
  }
  export interface IMedium {
      sizeName: string;
      url: string;
      width: number;
      height: number;
      actualWidth: number;
      actualHeight: number;
  }
  export interface ILarge {
      sizeName: string;
      url: string;
      width: number;
      height: number;
      actualWidth: number;
      actualHeight: number;
  }
  export interface IPhoneSmall {
      sizeName: string;
      url: string;
      width: number;
      height: number;
      actualWidth: number;
      actualHeight: number;
  }
  export interface IBest {
      sizeName: string;
      url: string;
      width: number;
      height: number;
      actualWidth: number;
      actualHeight: number;
  }
  export interface IOriginal {
      sizeName: string;
      url: string;
      actualWidth: number;
      actualHeight: number;
  }
  export interface IPhone {
      sizeName: string;
      url: string;
      width: number;
      height: number;
      actualWidth: number;
      actualHeight: number;
  }
  export interface ISizes3 {
      Small: ISmall;
      XLarge: IXLarge;
      Medium: IMedium;
      Large: ILarge;
      IPhoneSmall: IPhoneSmall;
      Best: IBest;
      Original: IOriginal;
      IPhone: IPhone;
  }
  export interface Image {
      sizes: ISizes3;
      id: string;
  }
  export interface ICategory {
      numId: number;
      id: string;
      name: string;
      shortName: string;
      localizedId: string;
  }
  export interface IMobile3 {
      url: string;
  }
  export interface IDefault3 {
      url: string;
  }
  export interface IFeatured3 {
      url: string;
  }
  export interface IMobile2x3 {
      url: string;
  }
  export interface IFeatured2x3 {
      url: string;
  }
  export interface IDefault2x3 {
      url: string;
  }
  export interface ISizes4 {
      mobile: IMobile3;
      default: IDefault3;
      featured: IFeatured3;
      'mobile@2x': IMobile2x3;
      'featured@2x': IFeatured2x3;
      'default@2x': IDefault2x3;
  }
  export interface ILogo3 {
      sizes: ISizes4;
  }
  export interface IRetailer2 {
      id: string;
      name: string;
      logo: ILogo3;
      userId: number;
      userHandle: string;
      userImage: string;
      urlIdentifier: string;
      favIcon: string;
      effectiveContentLocale: string;
      handle: string;
      deeplinkSupport: boolean;
      hostDomain: string;
  }
  export interface IStartDate {
      date: string;
      timestamp: number;
      friendly: string;
  }
  export interface IEndDate {
      date: string;
      timestamp: number;
      friendly: string;
  }
  export interface IPromotionalDeal {
      id: number;
      type: string;
      typeLabel: string;
      title: string;
      shortTitle: string;
      retailer: IRetailer2;
      startDate: IStartDate;
      endDate: IEndDate;
  }
  export interface IProduct {
      id: number;
      name: string;
      brandedName: string;
      unbrandedName: string;
      currency: string;
      price: number;
      priceLabel: string;
      inStock: boolean;
      retailer: IRetailer;
      brand: IBrand;
      locale: string;
      description: string;
      clickUrl: string;
      pageUrl: string;
      urlIdentifier: string;
      image: Image;
      alternateImages: any[];
      colors: any[];
      sizes: any[];
      categories: ICategory[];
      extractDate: string;
      badges: any[];
      promotionalDeal: IPromotionalDeal;
      favoriteCount: number;
      commentCount: number;
      hasFavorite: boolean;
      seeMoreLabel: string;
      seeMoreUrl: string;
      preOwned: boolean;
      rental: boolean;
  }

}

declare module '@ssjs/shopstyle-node-common/dist/common/interfaces/user' {
  export interface IUser {
      id: number;
      handle: string;
      firstName: string;
      lastName: string;
      description: string;
      image: string;
      locale: string;
      type: string;
      apiKey: string;
      shopSensePartner: boolean;
      shopSenseStatus: string;
      apiPartner: boolean;
      partnerUserId: string;
      email: string;
      authLevel: string;
      hasShoppingProfiles: boolean;
      numFavorites: number;
      numFriends: number;
      numFollowers: number;
      saleAlertSubscription: string;
      following: boolean;
      followed: boolean;
      verified: boolean;
      shopEditor: boolean;
      permissions: any[];
      faveUser: boolean;
      allowsEmail: boolean;
      loginToken: string;
      loginTimestamp: string;
      $isLoggedIn: boolean;
      paypalEmail: string;
      paypalFirstName: string;
      paypalLastName: string;
  }

}

declare module '@ssjs/shopstyle-node-common/dist/config/all/defaults' {
  var _default: {
      defaultRequestParams: {
          pid: string;
      };
  };
  export = _default;

}

declare module '@ssjs/shopstyle-node-common/dist/config/env/development' {
  var _default: {
      env: string;
      fbAppId: string;
      apiRoot: string;
      secureApiRoot: string;
      tld: string;
      sslConfig: {
          useSsl: boolean;
          keyFile: string;
          certFile: string;
      };
  };
  export = _default;

}

declare module '@ssjs/shopstyle-node-common/dist/config/env/production' {
  var _default: {
      env: string;
      fbAppId: string;
      apiRoot: string;
      secureApiRoot: string;
      tld: string;
  };
  export = _default;

}

declare module '@ssjs/shopstyle-node-common/dist/config/env/qa' {
  var _default: {
      env: string;
      fbAppId: string;
      apiRoot: string;
      secureApiRoot: string;
      tld: string;
  };
  export = _default;

}

declare module '@ssjs/shopstyle-node-common/dist/config/env/test' {
  var _default: {
      env: string;
  };
  export = _default;

}

declare module '@ssjs/shopstyle-node-common/dist/config/private' {
  var _default: {};
  export = _default;

}

declare module '@ssjs/shopstyle-node-common/dist/server/boot/command' {
  import * as express from 'express';
  var _default: (server: express.Application) => void;
  export = _default;

}

declare module '@ssjs/shopstyle-node-common/dist/server/boot/explorer' {
  var _default: (server: any) => void;
  export = _default;

}

declare module '@ssjs/shopstyle-node-common/dist/server/boot/proxy' {
  import * as express from 'express';
  var _default: (server: express.Application) => void;
  export = _default;

}

declare module '@ssjs/shopstyle-node-common/dist/server/boot/rest-api' {
  var _default: (server: any) => void;
  export = _default;

}

declare module '@ssjs/shopstyle-node-common/dist/server/dependencies' {
  /// <reference path="../../typings/tsd.d.ts" />

}

declare module '@ssjs/shopstyle-node-common/dist/server/middleware/serve-index' {
  var _default: (staticDir?: string, fileName?: string) => (req: any, res: any, next: any) => void;
  export = _default;

}

declare module '@ssjs/shopstyle-node-common/dist/server/middleware/webpack-dev' {
  var _default: () => any;
  export = _default;

}

declare module '@ssjs/shopstyle-node-common/dist/server/middleware/webpack-hot' {
  var _default: () => any;
  export = _default;

}

declare module '@ssjs/shopstyle-node-common/dist/server/server' {
  export class ShopStyleNodeServer {
      app: any;
      loopback: any;
      config: any;
      private enableSsl;
      private sslOptions;
      constructor(config: any, loopback: any);
      private readSslFile(filePath);
      private boot();
      private start();
  }

}

declare module '@ssjs/shopstyle-node-common/dist/server/services/webpack' {
  export const config: any;
  export const compiler: any;

}

